unit glcl18;
{ L\            '
  L\            '
  L\            '
  L\            '
  LLLLLLL\      '
  \\\\\\\\      '
}
interface
{$DEFINE LINTERF}
{$DEFINE OVERLOADS}
// define GLCLINTERF to use iGLShower
// or use tglSafeObj
uses windows,OpenGL,sysutils,vect3d,controls,classes,graphics,{$DEFINE LINTERF}lists;
const
sec = 1/86400;
sqrt3 : single = 1.73205;
sqrt2 : single = 1.41421;
pi180 : single = pi/180;
glclFace : cardinal = gl_Front;
type
colortype = (GLCL_AMBIENT,GLCL_DIFFUSE,GLCL_SPECULAR,GLCL_EMISSION);
coloruse = set of colortype;
floatar4 = array[0..3] of glfloat;
pfloatar4 = ^floatar4;
psingle = ^single;

{MAIN INTERFACE}
iGLShower = interface
['{2D0C1740-2A7E-11D4-BD48-CBDEE1EF1053}']
procedure Show;
end;

tglobj = class(TContainer,iGLShower)
xt,yt,zt,xr,yr,zr : single;{TRANSLATE AND ROTATE}
colorenabled,visible : boolean;
color : floatar4;{array[0..3] of glFLOAT;}
destroyed : boolean;
uscolor : coloruse;
enhcolor : tglobj;
postcoloring : boolean;
constructor create(aid : smallint;x,y,z : single);
procedure setpos(x,y,z : single);virtual;
procedure setrotate(x,y,z : single);virtual;
procedure setcolor(r,g,b,u : single);{$IFDEF OVERLOADS}
overload;{$ENDIF}virtual;
{$IFDEF OVERLOADS}
procedure setcolor(clr : floatar4);overload;virtual;
{$ENDIF}
procedure SHOW;virtual;
procedure beginshow;virtual;
procedure processlist;virtual;
procedure endshow;virtual;
procedure showself;virtual;
destructor destroy;override;
{function _Release: Integer; stdcall;}
end;

tglSafeObj = class(tglobj){FOR CALLS BY IGLSHOWER}
procedure processlist;override;
end;

tglButton = class(tglobj)
xb,yb,zb : single;
OnClick : tNOTIFYEvent;
lsh : tshiftstate;
lx,ly,lz : single;
constructor create(aid : smallint;x,y,z,axb,ayb,azb : single;what : tNOTIFYEVENT);
function  Hclick(xc,yc,zc : single;sh : tshiftstate) : boolean;virtual;
end;

tglCursor = class(tglobj)
public
wH,ww : integer;
CHCX,CHCY  : single;
rx1,ry1,rx2,ry2 : integer;
shx,shy : single;
mx,my,mz : single;
visu : tglobj;
public
constructor create(aid: smallint; {PANEL DIMEN}aww, awh: integer; AXM,AYM,AZM {RIGHT BOTTOM CORNER}
 : single;ashx,ashy : single;avisu : tglobj);
procedure   curmovto(x,y : integer;sh : tshiftstate);virtual;
procedure   broadcast(xc,yc,zc : single;shift : TShiftstate);virtual;
procedure   show;override;
end;

iGLEnhColor = interface
['{3C45E0E0-5401-11D4-BD48-8E0C2512FE7B}']
procedure ENCOLOR;
procedure HIDECOLOR;
end;

tglenhcol = class(tglobj,iglEnhcolor)
amb,dif,spec,emi : floatar4;
shine : single;
procedure setENHcol(uc : coloruse;r,g,b,a : single);dynamic;
procedure beginshow;override;
procedure IglEnhcolor.ENCOLOR = show;
procedure hidecolor;virtual;
end;

tglLight = class(tglEnhcol)
alwaysredraw : boolean;
refrCOl,refrPos,refrDIR : boolean;
modified       : boolean;
lnum           : integer; { TODO -cUPGRADE : make tlight.autocreate as overload }
constructor create(aid : smallint;x,y,z : single;lightnum : integer);
constructor autocreate(aid : smallint;x,y,z : single);
procedure   setvisibility(val : boolean);
procedure showself;override;{only colors}
procedure setlightparamv(i : integer;var val);
procedure setlightparamf(i : integer;val : single);
end;

tglassigner = class(tglobj)
using : boolean;
constructor create(aid : smallint;x,y,z : single);
constructor assigncreate(aid : smallint;x,y,z : single;asgn : pointer);dynamic;
procedure assign(asgn : pointer);dynamic;
end;

tglassignerCLASS = class of tglassigner;

tglreAssigner = class(tglobj)
asgnto,lnkto : tglobj;
laddr,maddr : smallint;
constructor create(aid : smallint;assignto,linkto : tglobj;linkaddr,maxaddr : smallint);
procedure add(item : tlitem);override;
procedure addr(item : tlitem);override;
procedure show;override;
end;

iGLResizeable = interface
['{D5DABD40-235D-11D4-BD48-812EBF5CDF54}']
procedure SetSize(sz : single);
function  GetSize : single;
property iSIZE : single read GETSIZE write SETSIZE;
end;

tglsphere = class(tglassigner,iGLresizeable)
radius : single;
constructor create(aid : smallint;x,y,z,r : single);
procedure SetSIze(sz : single);virtual;
function  GetSize : single;virtual;
procedure assign(asgn : pointer);override;
procedure showself;override;
end;

tglMover = class(tglassigner)
xm,ym,zm,xrt,yrt,zrt : single;
xs,ys,zs,xsr,ysr,zsr : single;
lxt,lyt,lzt,lxr,lyr,lzr : single;
starttime,movetime : double;
autodestroy : boolean;
moving : boolean;
constructor create(aid : smallint;x,y,z : single);
procedure startmove(ax,ay,az,axr,ayr,azr : single;time : double);dynamic;
procedure assign(asgn : pointer);override;
procedure show;override;
procedure changeobjs;virtual;
procedure killall;override;
end;

tglVmover = class(tglMover)
ltime : double;
procedure startmove(ax,ay,az,axr,ayr,azr : single;time : double);override;
procedure show;override;
end;

tglpoint = class(tglobj)//rarely used,use TGLSpeed point
sz : single;
{$IFDEF OVERLOADS}
constructor create(aid : smallint;x,y,z : single;size : single);overload;
{$ENDIF}
procedure showself;override;
end;

tgllist = class(tglassigner)
listnum : cardinal;
constructor create(aid : smallint;x,y,z : single);
procedure showself;override;
procedure showself2;virtual;
procedure beginlist;dynamic;
procedure endlist;dynamic;
procedure killlist;dynamic;
procedure recompile;dynamic;
procedure assign(asgn : pointer);override;
destructor destroy;override;
end;

tglReader = class(tglObj)//reads 3di files
datap : pointer;
dsize : integer;
constructor create(aid : smallint;x,y,z : single;fname : string);
constructor createV(aid : smallint;x,y,z : single;data : pointer;datasize : integer);virtual;
procedure showself;override;
destructor destroy;override;
end;

tglcube = class(tglassigner,iglresizeable)
size : single;
constructor create(aid : smallint;x,y,z,a : single);
procedure assign(asgn : pointer);override;
procedure showself;override;
procedure setsize(sz : single);virtual;
function  GetSize : single;virtual;
end;

tglrotcube = class(tglcube)//little slower than usual,but is textured properly
procedure showself;override;
end;

tgltetrahedron = class(tglcube)
procedure showself;override;
end;

tgljumper = class(TglMOVER)//jumping mover
ax,ay,az,axr,ayr,azr : single;
vx,vy,vz,vxr,vyr,vzr : single;
procedure startmove(ax,ay,az,axr,ayr,azr : single;time : double);override;
procedure startjump(jx,jy,jz : single);virtual;
procedure show;override;
end;

tglWaiter = class(tglobj)//object that is shown in specified time
tm1,tm2 : double;
autodestroy : boolean;
constructor create(aid : smallint;time1,time2 : double);
procedure workfromtill(time1,time2 : double);
procedure show;override;
end;

tglARROW = class(tgllist)//round arrow
ll,rad : single;
pobj : pointer;
constructor create(aid : smallint;x,y,z,l,r : single);
procedure showself2;override;
end;

color4b = array[1..4] of byte;

texfunc = function(x,y : integer) : color4b;

tglTexture = class(tglEnhCol)
tex : pointer;
xtl,ytl : integer;
constructor create(aid : smallint;xl,yl : integer;texptr : pointer);
constructor createbyfunc(aid : smallint;xl,yl : integer;func : texfunc);
procedure beginshow;override;
procedure hidecolor;override;
destructor destroy;override;
end;

tglBitMap = class(tglobj)
p : pointer;
xtl,ytl : integer;
constructor createF(aid : smallint;fname : string);
{constructor create(aid : smallint;xl,yl : integer;p : pointer);}
constructor createFromGraphic(aid : smallint;GRPH: TGraphic;AA : byte);
procedure  ResetFromGraphic(GRPH: TGraphic;AA : byte);
procedure showself;override;
destructor destroy;override;
end;

tglNURBSCurve = class(tglobj)
curvep,sknots,tknots : pointer;
maxt,maxs :  integer;
constructor create(aid : smallint;x,y,z : single;ms,mt : integer;curvp : pointer);
constructor Load(aid : smallint;x,y,z : single;ms,mt : integer;var fl : file);
procedure showself;override;
destructor destroy;override;
end;

tglMesh = class(tglNurbsCurve) {but i think its better to declare nurbs from mesh}
{maxt,maxs :  integer;}
constructor create(aid : smallint;x,y,z : single;ms,mt : integer;pts : pointer);
constructor Load(aid : smallint;x,y,z : single;ms,mt : integer;var fl : file);
function getpoint(p : pointer;x,y,z : integer) : single;virtual;
procedure putpoint(p : pointer;x,y,z : integer;val : single);virtual;
procedure calcnormals;virtual;
procedure showself;override;
destructor destroy;override;
end;

tglFont = class(tglObj{only for compatibilty}) //font reads .fnt files
sz : integer;
chars : array[0..255] of pointer;
autoshift : boolean;
{xt,yt,zt are used for scaling)}
{create is NOT available!!!!}
constructor load(aid : smallint;fname : string);
procedure write(ch : byte;var xsh,ysh : single);virtual;
procedure charsize(ch : byte;var xsh,ysh : single);virtual;
destructor destroy;override;
end;

tglString = class(tglList)//uses font
fst : string;
xf,yf : single;
fnt : tglFont;
maxxsh,maxysh : single;
procedure setstr(val : string);
property pSTR : string read fst write setstr;
constructor create(aid : smallint;x,y,z : single;astr : string;afnt :tglfont{if nil uses default});
procedure showself2;override;
end;

tglTTfont = class(tglObj)//A TRUETYPE FONT
lbase : cardinal;
constructor create(aid : smallint;DC:HDC{of glpanel};
extr,devi : single;hf : HFONT);
DESTRUCTOR DESTROY;OVERRIDE;
END;

tglTTString = class(tglObj){TrueType font string,is SLOWER than tglString,but looks better}
xf,yf,zf : single;
str : string;
fnt : tglTTFont;
constructor create(aid : smallint;x,y,z : single;xs,ys,zs : single;astr : string;ttf : tglTTFOnt);
procedure showself;override;
end;

procedure inittextures;
function getfreeaddr(obj : tglobj;faddr: smallint) : smallint;
procedure initsurfaces;
function incptr(p : pointer;sh : integer) : pointer;
function isBetween(a,a1,a2 : single) : boolean;
function xglfind(p : pointer;id : smallint) : tglobj;
procedure xglFrameRect(x1,y1,x2,y2 : single);
{$IFDEF OVERLOADS}
function getfid:smallint;overload;
{$ENDIF}

const
nilfloatar4 : floatar4 = (0,0,0,0);
ablackalpha : floatar4 = (0,0,0,1);


var
mainobj : tglobj;
baseshine : single;{shininess}
basequal  : integer;{for slices of quadrics}
aquadobj,theNURB  : pointer;
curtime   : double;
multitexture : boolean = false;{if textures need reload each time}
deffont : tglFont = nil;{default font}
single1 : single;       {single1 reader bank}
specularSETHIDE : boolean = false;{colorset conventions}
EMISSIONSETHIDE : boolean = TRue;
ttstringkind : integer = (wgl_font_polygons);
clamprotation : boolean = true;
implementation
function getfid:smallint;overload;
begin
result := getfid(mainobj);
end;
procedure xglFrameRect(x1,y1,x2,y2 : single);
begin
glBegin(GL_Line_Loop);
glnormal3f(0,0,1);
glVertex2f(x1, y1);
glVertex2f(x2, y1);
glVertex2f(x2, y2);
glVertex2f(x1, y2);
glEnd;
end;
function xglfind(p : pointer;id : smallint) : tglobj;
begin
if p=nil then xglfind := nil else

xglfind := tglobj(xfind(p,id));
end;
constructor tglBitmap.createF(aid : smallint;fname : string);
var
x,y,z : integer;
image : array[1..64,1..64] of color4b;
f : file of byte;
begin
if fileexists(fname) then
begin
assignfile(f,fname);
reset(f);
for x := 1 to 64 do
 for y := 1 to 64 do
  for z := 1 to 4 do
  read(f,image[x,y,z]);
   inherited create(aid,0,0,0);
xtl := 64;
ytl := 64;
getmem(p,xtl*ytl*4);
move(image,p^,xtl*ytl*4);
 end
 else
 begin
 raise exception.create('TEXTURE FILE DOESN''T EXIST');
 end;
end;

constructor tglButton.create(aid : smallint;x,y,z,axb,ayb,azb : single;what : tNOTIFYEVENT);
begin
inherited create(aid,x,y,z);
xb := axb;yb := ayb;zb := azb;
onClick := what;
end;

function isBetween(a,a1,a2 : single) : boolean;
begin
if ((a >= a1) and (a <= a2)) or ((a <= a1) and (a >= a2)) then isBetween := true
 else isBetween := false;
end;

function  tglButton.hclick(xc,yc,zc : single;sh : tshiftstate) : boolean;{no rotate and traNslate !!!}
begin
if isbetween(xc,xt,xb) and isbetween(yc,yt,yb) and isBetween(zc,zt,zb)
then begin
lsh := sh;
lx := xc;ly := yc;lz := zc;
 if assigned(onclick) then onclick(self); hclick := true end
else hclick := false;
end;

constructor tglString.create(aid : smallint;x,y,z : single;astr : string;afnt : tglfont);
begin
fst := astr;fnt := afnt;
xf := 1;yf := 1;
if fnt = nil then fnt := deffont;
if fnt = nil then raise exception.Create('NO FONTS AVAIL');
inherited create(aid,x,y,z);
end;

procedure tglString.setstr(val: string);
begin
if fst = val then exit;
fst := val;
recompile;
end;

procedure tglString.showself2;
var x : integer;
shx,shy : single;
begin
maxxsh := 0;
maxysh := 0;
glNormal3f(0,0,1);{default}
shx := 0;shy := 0;
fnt.xt := xf;fnt.yt := yf;
for x := 1 to length(fst) do
begin
if shy > maxysh then maxysh := shy;
if shx > maxxsh then maxxsh := shx;
if fst[x] = #$D then begin  shx := 0;continue end;   {CR}
if fst[x] = #$A then begin shy := shy-1;continue;end;{LF}
fnt.write(byte(fst[x]),shx,shy);
if not fnt.autoshift then shx := shx+xf;
end;
if shy > maxysh then maxysh := shy;
if shx > maxxsh then maxxsh := shx;
maxxsh := maxxsh*xf;
maxysh := maxysh*yf;
end;

procedure tgllist.recompile;
begin
killlist;
beginlist;
showself2;
endlist;
end;


constructor tglfont.load(aid : smallint;fname : string);{ONLY FROM FNT files}
var x : integer;
f : file;
cp : pointer;
begin
inherited create(aid,1,1,1);
assignfile(f,fname);
reset(f,1);
getmem(chars[0],filesize(f));
blockread(f,chars[0]^,filesize(f));
sz := filesize(f);
cp := chars[0];
for x := 1 to 255 do
begin
 while byte(cp^)<> 0 do
 begin
  if byte(cp^) = 201 then begin autoshift := true;cp := incptr(cp,5);end;
  if byte(cp^) = 0 then break;
  cp := incptr(cp,2);
  while byte(cp^) = 3 do
  begin
  cp := incptr(cp,13);
  end;
  cp := incptr(cp,1);
 end;
cp := incptr(cp,1);
chars[x] := cp;
end;
closefile(f);
end;


destructor tglfont.destroy;
begin
freemem(chars[0],sz);
inherited destroy;
end;

procedure tglfont.write(ch : byte;var xsh,ysh : single);
var cp : pointer;
x,y,z : single;
begin
cp := chars[ch];
repeat
case byte(cp^) of
0 : begin if autoshift then xsh := xsh + single1;exit;end;
1 : begin
cp := incptr(cp,1);
glbegin(byte(cp^));
cp := incptr(cp,1);
end;
2 : begin glENd;cp := incptr(cp,1);end;
3 : begin
cp := incptr(cp,1);
x := single(cp^);{!!!}cp := incptr(cp,4);
y := single(cp^);{!!!}cp := incptr(cp,4);
z := single(cp^);{!!!}cp := incptr(cp,4);
glVertex3f((x+xsh)*xt,(y+ysh)*yt,z*zt);
end;
4 : begin
cp := incptr(cp,1);
x := single(cp^);{!!!}cp := incptr(cp,4);
y := single(cp^);{!!!}cp := incptr(cp,4);
z := single(cp^);{!!!}cp := incptr(cp,4);
glNormal3f(x,y,z);
end;
201 : begin
cp := incptr(cp,1);
single1 := single(cp^);{!!!}cp := incptr(cp,4);
end;
end;
until integer(integer(cp)-integer(chars[ch])) > sz;
end;

{FILE MUST HAVE RECLEN = 1 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
function incptr(p : pointer;sh : integer) : pointer;
begin
incptr := ptr(integer(p) + sh);
end;
{ Reader commands :
0 - end read
1 - glBegin(
  GL_POINTS                 = $0000;
  GL_LINES                  = $0001;
  GL_LINE_LOOP              = $0002;
  GL_LINE_STRIP             = $0003;
  GL_TRIANGLES              = $0004;
  GL_TRIANGLE_STRIP         = $0005;
  GL_TRIANGLE_FAN           = $0006;
  GL_QUADS                  = $0007;
  GL_QUAD_STRIP             = $0008;
  GL_POLYGON                = $0009;)

2 - glEnd
3 - glVertex3f 3 * single * numof
4 - glNormal3f 3*single
enh commands :
NO 103 : glVertices3f - first byte is count of that vertices -

201 :  setsingle1

}

procedure tglReader.showself;
var cp : pointer;
x,y,z : single;
begin
cp := datap;
repeat
case byte(cp^) of
0 : exit;
1 : begin
cp := incptr(cp,1);
glbegin(byte(cp^));
cp := incptr(cp,1);
end;
2 : begin glENd;cp := incptr(cp,1);end;
3 : begin
cp := incptr(cp,1);
x := single(cp^);{!!!}cp := incptr(cp,4);
y := single(cp^);{!!!}cp := incptr(cp,4);
z := single(cp^);{!!!}cp := incptr(cp,4);
glVertex3f(x,y,z);
end;
4 : begin
cp := incptr(cp,1);
x := single(cp^);{!!!}cp := incptr(cp,4);
y := single(cp^);{!!!}cp := incptr(cp,4);
z := single(cp^);{!!!}cp := incptr(cp,4);
glNormal3f(x,y,z);
end;
201 : begin
cp := incptr(cp,1);
single1 := single(cp^);{!!!}cp := incptr(cp,4);
end;
end;
until integer(integer(cp)-integer(datap)) > dsize;
end;

constructor tglReader.create(aid : smallint;x,y,z : single;fname : string);
var f : file;
begin
inherited create(aid,x,y,z);
assignfile(f,fname);
reset(f,1);
dsize := filesize(f);
getmem(datap,dsize);
blockread(f,datap^,dsize);
end;


destructor tglReader.destroy;
begin
freemem(datap,dsize);
end;

constructor tglMesh.Load(aid : smallint;x,y,z : single;ms,mt : integer;var fl : file);

var ppp : pointer;
begin
getmem(ppp,mt*ms*4*3);
blockread(fl,ppp^,mt*ms*4*3);
create(aid,x,y,z,ms,mt,ppp);
freemem(ppp,mt*ms*4*3);
end;

function tglMesh.getpoint(p : pointer;x,y,z : integer) : single;
var ps : psingle;
begin
ps := ptr(integer(p)+((z-1)+(x-1)*3*maxt+(y-1)*3)*4);
getpoint := ps^;
end;
procedure tglMesh.putpoint(p : pointer;x,y,z : integer;val : single);
var ps : psingle;
begin
ps := ptr(integer(p)+((z-1)+(x-1)*3*maxt+(y-1)*3)*4);
ps^ :=val;
end;

procedure tglMesh.calcnormals;
var x,y : integer;
n : tpoint3d;
p1,p2,p3 : ppoint3d;

function getpoint3d(p : pointer;x,y : integer) : ppoint3d;
begin
getpoint3d :=ptr(integer(p)+((x-1)*3*maxt+(y-1)*3)*4)
end;

procedure putpt(x,y : integer;pt : tpoint3d);
begin
putpoint(sknots,x,y,1,pt[0]);
putpoint(sknots,x,y,2,pt[1]);
putpoint(sknots,x,y,3,pt[2]);
end;

procedure blendpt(x,y : integer;pt : tpoint3d);
var i : integer;
s : single;
begin
for i := 1 to 3 do
begin
s := getpoint(sknots,x,y,i);
s := (s+pt[i-1])/2;
putpoint(sknots,x,y,i,s);
end;
end;
 begin
    p1 := getpoint3d(curvep,1,1);
    p2 := getpoint3d(curvep,1,1+1);
    p3 := getpoint3d(curvep,1+1,1);
   perpnorm(p1^,p2^,p3^,n);
   putpt(1,1,n);putpt(1+1,1,n);
    putpt(1,1+1,n);
    for x := 1 to maxs-1 do
     for y := 1 to maxt-1 do
     begin
    p1 := getpoint3d(curvep,x,y);
    p2 := getpoint3d(curvep,x,y+1);
    p3 := getpoint3d(curvep,x+1,y);
        perpnorm(p1^,p2^,p3^,n);
  if y <> 1 then  blendpt(x,y,n){blend)}
     else putpt(x,y,n);
     putpt(x+1,y,n);
   if (x <> 1) and (y <> maxt-1) then blendpt(x,y+1,n) {blend}
    else putpt(x,y+1,n);
   end;
    p1 := getpoint3d(curvep,maxs,maxt-1);
    p2 := getpoint3d(curvep,maxs-1,maxt);
    p3 := getpoint3d(curvep,maxs,maxt);
    perpnorm(p1^,p2^,p3^,n);
   putpt(maxs,maxt,n);
 end;


constructor tglMesh.create(aid : smallint;x,y,z : single;ms,mt : integer;pts : pointer);
begin
inherited create(aid,x,y,z,ms,mt,pts);
freemem(sknots,(maxs+3)*4);
freemem(tknots,(maxt+3)*4);
getmem(sknots,maxs*maxt*3*4);
calcnormals;
end;

procedure tglMesh.showself;
var x,y : integer;
x1,y1,z1 : single;
begin
    for x := 1 to maxs-1 do
    begin
    glBegin(gl_triangle_strip);
     for y := 1 to maxt do
     begin
x1 := getpoint(sknots,x,y,1); y1 := getpoint(sknots,x,y,2);
          z1 := getpoint(sknots,x,y,3);
glNormal3f(x1,y1,z1);
x1 := getpoint(curvep,x,y,1); y1 := getpoint(curvep,x,y,2);
          z1 := getpoint(curvep,x,y,3);
     glVertex3f(x1,y1,z1);

x1 := getpoint(sknots,x+1,y,1); y1 := getpoint(sknots,x+1,y,2);
z1 := getpoint(sknots,x+1,y,3);
glNormal3f(x1,y1,z1);
x1 := getpoint(curvep,x+1,y,1); y1 := getpoint(curvep,x+1,y,2);
     z1 := getpoint(curvep,x+1,y,3);
     glVertex3f(x1,y1,z1);

     end;
     glend;
    end;
    end;



destructor tglMesh.destroy;
begin
freemem(curvep,maxt*maxs*4*3);
curvep := nil;
freemem(sknots,maxt*maxs*4*3);
sknots := nil;
inherited destroy;
end;

destructor tglNurbscurve.destroy;
begin
if curvep <> nil then freemem(curvep,maxt*maxs*4*3);
if sknots <> nil then freemem(tknots,(maxt + 3)*4);
freemem(sknots,(maxs + 3)*4);
inherited destroy;
end;

procedure initsurfaces;
begin
glEnable(gl_normalize);
glenable(gl_auto_normal);
end;

constructor tglNurbsCurve.Load(aid : smallint;x,y,z : single;ms,mt : integer;var fl : file);
var ppp : pointer;
begin
getmem(ppp,mt*ms*4*3);
blockread(fl,ppp^,mt*ms*4*3);
create(aid,x,y,z,ms,mt,ppp);
freemem(ppp,mt*ms*4*3);
end;

constructor tglNurbsCurve.create(aid : smallint;x,y,z : single;ms,mt : integer;curvp : pointer);
var p : ^single; i : integer;cur : single;
procedure setsingle(ps : pointer;ofss : integer;val : single);
begin p := ptr(integer(ps)+ofss*4); p^ := val;
end;
begin
inherited create(aid,x,y,z);
if curvp = nil then raise exception.create('NIL IN tglnurbscurve.create')
else begin
maxt := mt;maxs :=ms;
getmem(curvep,maxt*maxs*4*3);
move(curvp^,curvep^,maxt*maxs*4*3);
getmem(sknots,(maxs + 3)*4);
for i := 0 to 2 do setsingle(sknots,i,0);
cur := 0;
for i := 3 to maxs do begin cur := cur + 1;setsingle(sknots,i,cur) end;
for i := maxs+ 1 to maxs+2 do setsingle(sknots,i,cur);
getmem(tknots,(maxt + 3)*4);
for i := 0 to 2 do setsingle(tknots,i,1);
cur := 1;
for i := 3 to maxt do begin cur := cur + 1;setsingle(tknots,i,cur) end;
for i := maxt+ 1 to maxt+2 do setsingle(tknots,i,cur);
end;
end;

procedure tglNURBSCURVE.showself;
begin
    gluBeginSurface(theNurb);
    gluNurbsSurface(theNurb,
        maxs+3, sknots,
        maxt+3, tknots,
        3 * maxt,
        3,
        curvep,
        3, 3,
        GL_MAP2_VERTEX_3);
    gluendsurface(theNurb);
end;


procedure tglRotCube.showself;
var a : single;
begin
a := size/2;
 {FRONT}
glBegin(Gl_POLYGON);
glNormal3f(0,0,1);
glvertex3f(a,a,a);
glvertex3f(-a,a,a);
glvertex3f(-a,-a,a);
glvertex3f(a,-a,a);
glend;
 {rear}
glBegin(Gl_POLYGON);
glNormal3f(0,0,-1);
glvertex3f(a,a,-a);
glvertex3f(a,-a,-a);
glvertex3f(-a,-a,-a);
glvertex3f(-a,a,-a);
glend;

glRotatef(90,1,0,0);
glBegin(Gl_POLYGON);
glNormal3f(0,0,1);
glvertex3f(a,a,a);
glvertex3f(-a,a,a);
glvertex3f(-a,-a,a);
glvertex3f(a,-a,a);
glend;
glRotatef(90,0,1,0);
glBegin(Gl_POLYGON);
glNormal3f(0,0,1);
glvertex3f(a,a,a);
glvertex3f(-a,a,a);
glvertex3f(-a,-a,a);
glvertex3f(a,-a,a);
glend;
glRotatef(90,0,1,0);
glBegin(Gl_POLYGON);
glNormal3f(0,0,1);
glvertex3f(a,a,a);
glvertex3f(-a,a,a);
glvertex3f(-a,-a,a);
glvertex3f(a,-a,a);
glend;
glRotatef(90,0,1,0);
glBegin(Gl_POLYGON);
glNormal3f(0,0,1);
glvertex3f(a,a,a);
glvertex3f(-a,a,a);
glvertex3f(-a,-a,a);
glvertex3f(a,-a,a);
glend;

end;

procedure tglCube.showself;
var a : single;
begin
a := size/2;
glBegin(Gl_Quads);
glNormal3f(0,0,1);
glvertex3f(a,a,a);
glvertex3f(-a,a,a);
glvertex3f(-a,-a,a);
glvertex3f(a,-a,a);

glNormal3f(0,0,-1);
glvertex3f(a,a,-a);
glvertex3f(a,-a,-a);
glvertex3f(-a,-a,-a);
glvertex3f(-a,a,-a);


glNormal3f(0,1,0);
glvertex3f(a,a,a);
glvertex3f(a,a,-a);
glvertex3f(-a,a,-a);
glvertex3f(-a,a,a);

glNormal3f(0,-1,0);
glvertex3f(a,-a,a);
glvertex3f(-a,-a,a);
glvertex3f(-a,-a,-a);
Glvertex3f(a,-a,-a);
glNormal3f(1,0,0);
glvertex3f(a,a,a);
glvertex3f(a,-a,a);
glvertex3f(a,-a,-a);
glvertex3f(a,a,-a);
glNormal3f(-1,0,0);
glvertex3f(-a,a,a);
glvertex3f(-a,a,-a);
glvertex3f(-a,-a,-a);
glvertex3f(-a,-a,a);
glend;
end;

destructor tglTexture.destroy;
begin
freemem(tex,xtl*ytl*4);
inherited destroy;
end;

constructor tgltexture.create(aid : smallint;xl,yl : integer;texptr : pointer);
begin
inherited create(aid,0,0,0);
xtl := xl;
ytl := yl;
getmem(tex,xtl*ytl*4);
move(texptr^,tex^,xtl*ytl*4);
if not multitexture then
    glTexImage2D(GL_TEXTURE_2D, 0, 4, xtl, ytl, 0,
         GL_RGBA, GL_UNSIGNED_BYTE, tex);
end;

constructor tgltexture.createbyfunc(aid : smallint;xl,yl : integer;func : texfunc);
var
x,y : integer;
p : ^color4b;
begin
inherited create(aid,0,0,0);
xtl := xl;
ytl := yl;
getmem(tex,xtl*ytl*4);

for y := 1 to ytl do
for x := 1 to xtl do
 begin
 p :=ptr(integer(tex) + (y-1)*xtl*4 + (x-1)*4);
 p^ := func(x,y);
 end;

if not multitexture then
    glTexImage2D(GL_TEXTURE_2D, 0, 4, xtl, ytl, 0,
         GL_RGBA, GL_UNSIGNED_BYTE, tex);

end;

procedure tgltexture.beginshow;
begin
glPushmatrix;
gltranslatef(xt,yt,zt);
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);

if  multitexture then
    glTexImage2D(GL_TEXTURE_2D, 0, 4, xtl, ytl, 0,
         GL_RGBA, GL_UNSIGNED_BYTE, tex);
glENable(gl_TEXTURE_2d);

if colorenabled  and not postcoloring then begin
if glcl_AMBIENT IN USCOLOR then glmaterialfv(glclFace,GL_AMBIENT,@amb)
else glmaterialfv(glclFace,GL_AMBIENT,@AblackALPHA) ;
if glcl_SPECULAR IN USCOLOR then begin
glmaterialfv(glclFace,GL_SPECULAR,@spec);
glmaterialf(glclFace,GL_SHININESS,shine);
end else glmaterialfv(glclFace,GL_SPECULAR,@AblackALPHA);
if glcl_DIFFUSE IN USCOLOR then glmaterialfv(glclFace,GL_DIFFUSE,@dif)
else glmaterialfv(glclFace,GL_DIFFUSE,@AblackALPHA);
if glcl_EMISSION in uscolor then glmaterialfv(glclFace,GL_EMISSION,@emi)
else glmaterialfv(glclFace,GL_EMISSION,@AblackALPHA);
end;
processlist;
end;


procedure tgltexture.hidecolor;
begin
glFlush;
glDisable(gl_TEXTURE_2d);
end;

PROCEDURE inittextures;
begin
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glTExgeni(gl_S,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
    glTExgeni(gl_T,GL_TEXTURE_GEN_MODE,GL_OBJECT_LINEAR);
    glEnable(gl_TEXTURE_GEN_S);
    glEnable(gl_TEXTURE_GEN_T);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, gl_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
end;

procedure tglEnhcol.hidecolor;
begin
end;

procedure tglvmover.startmove(ax,ay,az,axr,ayr,azr : single;time : double);
begin
inherited startmove(ax,ay,az,axr,ayr,azr,time);
ltime := curtime;
end;


constructor tglreassigner.create(aid : smallint;assignto,linkto : tglobj;linkaddr,maxaddr : smallint);
begin
inherited create(aid,0,0,0);
asgnto := assignto;lnkto := linkto;
laddr := linkaddr;maddr := maxaddr;
end;
procedure tglreassigner.add(item : tlitem);
var
ass : tglassigner;
tcl : tglassignerclass;
x : smallint;
begin
if (asgnto = nil) or (lnkto = nil) then exit;
tcl := tglassignerclass(asgnto.classtype);
x := getfreeaddr(lnkto,laddr);
if x > maddr then begin
raise exception.Create('NO FREE IDS in Tglreassigner');
exit;
end;
ass := tcl.assigncreate(x,asgnto.xt,asgnto.yt,asgnto.zt,asgnto);
ass.add(item);
lnkto.add(ass);
end;
procedure tglreassigner.addr(item : tlitem);
var
ass : tglassigner;
tcl : tglassignerclass;
x : smallint;
begin
if (asgnto = nil )or (lnkto = nil )then exit;
tcl := tglassignerclass(asgnto.classtype);
x := getfreeaddr(lnkto,laddr);
if x > maddr then begin
raise exception.Create('NO FREE IDS in Tglreassigner');
exit;
end;
ass := tcl.assigncreate(x,asgnto.xt,asgnto.yt,asgnto.zt,asgnto);
ass.addr(item);
lnkto.add(ass);
end;

procedure tglreassigner.show;
begin end;


procedure tglmover.assign(asgn : pointer);
var
mv : tglmover;
begin
inherited assign(asgn);
mv := tglmover(asgn);    
xt := mv.xt;yt := mv.yt;zt := mv.zt;
xr := mv.xr;yr := mv.yr; zr := mv.zr;
xm := mv.xm;ym := mv.ym; zm := mv.zm; xrt := mv.xrt; yrt := mv.yrt;
zrt := mv.zrt;
xs := mv.xs; ys := mv.ys; zs := mv.zs; xsr := mv.zsr; ysr := mv.ysr;
zsr := mv.zsr;
lxt := mv.lxt; lyt := mv.lyt; lzt := mv.lzt;lxr := mv.lxr;
lyr := mv.lyr; lzr := mv.lzr;
starttime := mv.starttime; movetime := mv.movetime;
autodestroy := mv.autodestroy;
moving := mv.moving;
end;

function getfreeaddr(obj : tglobj;faddr: smallint) : smallint;
var
x : integer;
begin
x := faddr;
while obj.Find(x) <> nil do
 inc(x);
getfreeaddr := x;
end;

constructor tglpoint.create(aid: smallint; x, y, z, size: single);
begin
inherited create(aid,x,y,z);
sz := size;
end;

procedure tglpoint.showself;
begin
if sz <> 0 then 
glPointSize(sz);
glbegin(gl_points);
glvertex3i(0,0,0);
glend;
end;


procedure tglenhcol.setenhcol(uc : coloruse;r,g,b,a : single);
procedure setc(var i : floatar4;r,g,b,a : single);
begin i[0] := r;i[1] := g;i[2] := b;i[3] := a; end;
begin
colorenabled := true;
if glcl_AMBIENT in uc then setc(amb,r,g,b,a);
if glcl_DIFFUSE in uc then setc(dif,r,g,b,a);
if glcl_SPECULAR in uc then setc(spec,r,g,b,a);
if glcl_EMISSION in uc then setc(emi,r,g,b,a);
uscolor := uscolor + uc;
end;

procedure tgltetrahedron.showself;
var a,h,h2 : single;
begin
a := size;
h := a*sqrt3/2;
h2 := a*sqrt2/sqrt3;

glBegin(Gl_POLYGON);
glNormal3f(0,0,-1);
glvertex3f(-a/2,-h/3,-h2/3);
glvertex3f(0,2*h/3,-h2/3);
glvertex3f(a/2,-h/3,-h2/3);
glend;

glBegin(Gl_POLYGON);
glNormal3f(0,-0.9426,0.33333);
glvertex3f(-a/2,-h/3,-h2/3);
glvertex3f(a/2,-h/3,-h2/3);
glvertex3f(0,0,2*h2/3);
glend;


glBegin(Gl_POLYGON);
glNormal3f(0.8163,0.4713,0.33333);
glvertex3f(0,2*h/3,-h2/3);
glvertex3f(0,0,2*h2/3);
glvertex3f(a/2,-h/3,-h2/3);
glend;

glBegin(Gl_POLYGON);
glNormal3f(-0.8163,0.4713,0.33333);
glvertex3f(-a/2,-h/3,-h2/3);
glvertex3f(0,0,2*h2/3);
glvertex3f(0,2*h/3,-h2/3);
glend;
end;


procedure tglmover.killall;
begin
if not visible then
begin
xt :=xs+ xm;yt :=ys+ ym;zt := zs+zm;
xr := xsr + xrt;yr := ysr + yrt;zr := zsr + zrt;
changeobjs;
end;
inherited killall;
end;

procedure tglarrow.showself2;
begin
glPushMatrix;
gltranslatef(0,0,-ll*0.5);
gluQuadricOrientation(pobj,glU_INSIDE);
gluDisk(pobj,0,rad,basequal,1{basequal});
gluQuadricOrientation(pobj,glU_Outside);
glucylinder(pobj,rad,rad,ll*0.5,basequal,1{basequal});
gltranslatef(0,0,ll*0.5);
gluQuadricOrientation(pobj,glU_INSIDE);
gluDisk(pobj,0,rad*1.4,basequal,1{basequal});
gluQuadricOrientation(pobj,glU_Outside);
glucylinder(pobj,rad*1.4,0,ll*0.5,basequal,1{basequal});
glPopMatrix;
end;

constructor tglarrow.create(aid : smallint;x,y,z,l,r : single);
begin
ll := l;
rad := r;
pobj := gluNewQuadric;
inherited create(aid,x,y,z);
end;


procedure tglwaiter.workfromtill(time1,time2 : double);
begin
tm1 := time1;
tm2 := time2;
end;

constructor tglwaiter.create(aid : smallint;time1,time2 : double);
begin
inherited create(aid,0,0,0);
tm1 := time1;
tm2 := time2;
autodestroy := false;
end;

procedure tglwaiter.show;
var nw : double;
procedure showthem;
begin
beginshow;
endshow;
end;
begin
if tm1 = tm2 then begin showthem;exit end;{NO WAITER}
nw := curtime;
if tm1 < tm2 then
begin
if nw > tm2 then begin if autodestroy then destroyed := true; exit;end;
if tm1 < nw then showthem;
exit;
end;
if (nw < tm2) or (nw > tm1) then showthem;
end;

constructor tglassigner.assigncreate(aid : smallint;x,y,z : single;asgn : pointer);
begin
create(aid,x,y,z);
assign(asgn);
end;

procedure tgljumper.startmove(ax,ay,az,axr,ayr,azr : single;time : double);
begin
inherited startmove(ax,ay,az,axr,ayr,azr,time);
moving := false;
end;

procedure tglmover.changeobjs;//not inherited from processlist,be careful
 var p : tptrlitem;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
tglobj(p.ptr).xt:=tglobj(p.ptr).xt+ xt-lxt;
tglobj(p.ptr).yt:=tglobj(p.ptr).yt+ yt-lyt;
tglobj(p.ptr).zt:=tglobj(p.ptr).zt + zt-lzt;
tglobj(p.ptr).xr:=tglobj(p.ptr).xr + xr-lxr;
tglobj(p.ptr).yr:= tglobj(p.ptr).yr + yr-lyr;
tglobj(p.ptr).zr:=tglobj(p.ptr).zr + zr-lzr;
if clamprotation then begin
with tglobj(p.ptr) do begin
if (xr < 0) or (xr > 360) then xr := xr-360*trunc(xr/360);
if (yr < 0) or (yr > 360) then yr := yr-360*trunc(yr/360);
if (zr < 0) or (zr > 360) then zr := zr-360*trunc(zr/360);
end;
end;
p := tptrlitem(p.pn);
end;
lxt := xt;lyt := yt;lzt := zt;
lxr := xr;lyr := yr;lzr := zr;
end;


procedure tgljumper.startjump(jx,jy,jz : single);
var t2 : single;
begin
t2 := sqr(movetime);
if t2 = 0 then begin
raise exception.create('TIME IS ZERO');
exit;
end;
ax :=  8*jx/t2;  ay := 8*jy/t2;  az :=8* jz/t2;
vx := ax*movetime/2;vy := ay*movetime/2;vz := az*movetime/2;
starttime := curtime;
moving := true;
end;
procedure tgljumper.show;
var
novr,ps,tt,tt2 : double;
dx,dy,dz : single;
begin
novr := curtime;
tt := novr-starttime;
if (tt > movetime) and moving then
begin moving := false;
xt := xs + xm;yt := ys+ym;zt := zs+zm;
xr := xsr+xrt;yr:= ysr + yrt;zr := zsr+zrt;
if autodestroy then destroyed := true;
if not visible then changeobjs;
end;
if moving then
begin
ps := tt/movetime;
tt2 := sqr(tt)/2;
dx := vx*tt-ax*tt2; dy := vy*tt-ay*tt2; dz :=vz*tt-az*tt2;
xt := xs + xm*ps+ dx; yt := ys + ym * ps+dy;zt:=zs + zm*ps +dz;
xr := xsr + xrt*ps; yr := ysr + yrt * ps; zr := zsr + zrt*ps;
end;
if visible then
begin
beginshow;
showself;
endshow;
end
else if moving then  changeobjs;
end;



constructor tglcube.create(aid : smallint;x,y,z,a : single);
begin
size := a;
inherited create(aid,x,y,z);
end;

procedure tglcube.assign(asgn : pointer);
begin
inherited assign(asgn);
if tglobj(asgn).inheritsfrom(tglcube) then
begin
size := tglcube(asgn).size;
end;
end;

constructor tgllist.create(aid : smallint;x,y,z : single);
begin
inherited create(aid,x,y,z);
listnum := 0;
recompile;
end;

procedure tgllist.showself;
begin  glcalllist(listnum);  end;

procedure tgllist.showself2;  begin end;

procedure tgllist.beginlist;
begin killlist; listnum := glGenlists(1);
glNewList(listnum,GL_COMPILE);
end;

procedure tgllist.endlist; begin glEndList; end;

procedure tgllist.killlist;
begin
if glISlist(listnum) then gldeletelists(listnum,1)
end;

procedure tgllist.assign(asgn : pointer);
var a : tgllist;
begin
inherited assign(asgn);
if tglobj(asgn).inheritsfrom(tlist) then
begin
a := tgllist(asgn);
killlist;
listnum := a.listnum;
end;
end;

destructor tgllist.destroy;
begin
inherited destroy;
if not using then killlist;
end;

constructor tglmover.create(aid : smallint;x,y,z : single);
begin                       
inherited create(aid,x,y,z);
moving := false;
visible := false;
autodestroy := false;
end;

procedure tglmover.startmove(ax,ay,az,axr,ayr,azr : single;time : double);
begin
xm := ax;ym := ay;zm := az;
xrt := axr;yrt := ayr;zrt := azr;
xs := xt;ys := yt;zs :=zt;
xsr := xr;ysr := yr;zsr := zr;

lxt := xt;lyt := yt;lzt := zt;
lxr := xr;lyr := yr;lzr := zr;

starttime := curtime;
movetime := time;
moving := true;
end;

procedure tglVmover.show;
var ps : double;
begin
if (movetime <> 0)and (curtime - starttime > movetime) and moving then begin
ps := (curtime-ltime)*sec;
xt := xt + xm*ps; yt := yt + ym * ps; zt := zt + zm*ps;
xr := xr + xrt*ps; yr := yr + yrt * ps; zr := zr + zrt*ps;
moving := false;
if not visible then changeobjs;
if autodestroy then destroyed := true;
end;
if moving then
begin
ps := (curtime-ltime)/sec;
xt := xt + xm*ps; yt := yt + ym * ps; zt := zt + zm*ps;
xr := xr + xrt*ps; yr := yr + yrt* ps; zr := zr + zrt*ps;
ltime := curtime;
end;
if visible then
begin
beginshow;
showself;
endshow;
end else if moving then changeobjs{DEFAULT};
end;

procedure tglmover.show;
var nowt,ps : double;
begin
nowt := curtime;
if (nowt-starttime > movetime) and moving then begin
xt :=xs+ xm;yt :=ys+ ym;zt := zs+zm;
xr := xsr + xrt;yr := ysr + yrt;zr := zsr + zrt;
moving := false;
if not visible then changeobjs;
if autodestroy then destroyed := true;
end;
if moving then
begin
ps := (nowt-starttime)/movetime;
xt := xs + xm*ps; yt := ys + ym * ps; zt := zs + zm*ps;
xr := xsr + xrt*ps; yr := ysr + yrt * ps; zr := zsr + zrt*ps;
end;

if visible then
begin
beginshow;
showself;
endshow;
end else if moving then changeobjs{DEFAULT};
end;

procedure tglassigner.assign(asgn : pointer);
var a : tglobj;
begin
a := tglobj(asgn);
colorenabled := a.colorenabled;
uscolor := a.uscolor;
enhcolor := a.enhcolor;
color := a.color;
end;

procedure tglobj.setcolor(r,g,b,u : single);
begin
colorenabled := true;
color[0] := r;
color[1] := g;
color[2] := b;
color[3] := u;
end;

 procedure tglsphere.assign(asgn : pointer);
 begin
 inherited assign(asgn);
 if tglobj(asgn).inheritsfrom(tglsphere) then  radius := tglsphere(asgn).radius;
 end;

 constructor tglobj.create(aid : smallint;x,y,z : single);
 begin
 inherited create(aid);
 xt := x;
 yt := y;
 zt := z;
 colorenabled := false;
 visible := true;
 destroyed := false;
 enhcolor := nil;
 uscolor := [glcl_AMBIENT]+[GLCL_DIFFUSE];
 postcoloring := false;
 end;

procedure tglobj.setpos(x,y,z : single);
begin  xt := x;   yt := y;    zt := z;   end;

procedure tglobj.setrotate(x,y,z : single);
begin xr := x; yr := y; zr := z; end;


procedure tglobj.processlist;
var p,p1 : tptrlitem;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
   if tglobj(p.ptr).destroyed then
   begin
    p1 := P;
    repeat
     p1 := tptrlitem(p1.pn);
     if p1 = nil then break;
    until (p1.id <> p.Id);
    kill(p.id);
    p := p1;
   end
   else
   begin
   {$IFDEF GLCLINTERF}
   (p.ptr as iGLShower).Show;
   {$ELSE}
    tglobj(p.ptr).SHOW;
    {$ENDIF}
    p := tptrlitem(p.pn);
   end
 end;
end;

procedure tglobj.beginshow;
begin
glPushmatrix;
gltranslatef(xt,yt,zt);{OBJECT IS ROTATED,and it stayz on its place }
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);
if colorenabled and not postcoloring then begin
if glcl_AMBIENT IN USCOLOR then glmaterialfv(glclFace,GL_AMBIENT,@color)
else glmaterialfv(glclFace,GL_AMBIENT,@ABLACKALPHA) ;
if glcl_DIFFUSE IN USCOLOR then glmaterialfv(glclFace,GL_DIFFUSE,@color)
else glmaterialfv(glclFace,GL_DIFFUSE,@AblackALPHA);

if glcl_SPECULAR IN USCOLOR then begin
glmaterialfv(glclFace,GL_SPECULAR,@color);
glmaterialf(glclFace,GL_SHININESS,baseshine);
end else if not specularsethide then
glmaterialfv(glclFace,GL_SPECULAR,@AblackALPHA);
if glcl_EMISSION in uscolor then glmaterialfv(glclFace,GL_EMISSION,@color);
if enhcolor <> nil then
begin
(enhcolor as iglEnhColor).encolor;
end;
end;
processlist;
end;

procedure tglenhcol.beginshow;
begin
glPushmatrix;
gltranslatef(xt,yt,zt);{OBJECT IS ROTATED,and it stayz on its place }
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);
if colorenabled  and not postcoloring then begin
if glcl_AMBIENT IN USCOLOR then glmaterialfv(glclFace,GL_AMBIENT,@amb)
else glmaterialfv(glclFace,GL_AMBIENT,@AblackALPHA) ;
if glcl_SPECULAR IN USCOLOR then begin
glmaterialfv(glclFace,GL_SPECULAR,@spec);
glmaterialf(glclFace,GL_SHININESS,shine);
end else glmaterialfv(glclFace,GL_SPECULAR,@AblackALPHA);
if glcl_DIFFUSE IN USCOLOR then glmaterialfv(glclFace,GL_DIFFUSE,@dif)
else glmaterialfv(glclFace,GL_DIFFUSE,@AblackALPHA);
if glcl_EMISSION in uscolor then glmaterialfv(glclFace,GL_EMISSION,@emi)
else glmaterialfv(glclFace,GL_EMISSION,@AblackALPHA);
end;
processlist;
end;

procedure tglobj.endshow;
begin
if colorenabled and (enhcolor <> nil) then (enhcolor as iglEnhcolor).hidecolor;
if emissionSETHIDE and (glcl_EMISSION in uscolor) then glMaterialfv(glclFace,GL_EMISSION,@ABLACKALPHA);
if specularSETHIDE and (glcl_SPECULAR in uscolor) then glMaterialfv(glclFace,GL_SPECULAR,@ABLACKALPHA);
glpopmatrix;
end;

constructor tglassigner.create(aid : smallint;x,y,z : single);
begin
inherited create(aid,x,y,z);
using := false;
end;

destructor tglobj.destroy;
begin
destroyed := true;
inherited destroy;
end;

procedure tglobj.SHOW;
begin
if visible then begin
beginshow;
if postcoloring and colorenabled then begin
if glcl_AMBIENT IN USCOLOR then glmaterialfv(glclFace,GL_AMBIENT,@color)
else glmaterialfv(glclFace,GL_AMBIENT,@AblackALPHA) ;
if glcl_SPECULAR IN USCOLOR then begin
glmaterialfv(glclFace,GL_SPECULAR,@color);
glmaterialf(glclFace,GL_SHININESS,baseshine);
end else if not specularSETHIDE then
 glmaterialfv(glclFace,GL_SPECULAR,@AblackALPHA);
if glcl_DIFFUSE IN USCOLOR then glmaterialfv(glclFace,GL_DIFFUSE,@color)
else glmaterialfv(glclFace,GL_DIFFUSE,@AblackALPHA);
if glcl_EMISSION in uscolor then glmaterialfv(glclFace,GL_EMISSION,@color)
else if not emissionSETHIDE then glmaterialfv(glclFace,GL_EMISSION,@ABLACKALPHA);
if enhcolor <> nil then {enhcolor.SHOW;}(enhcolor as iglEnhcolor).encolor;
end;
showself;
endshow;
end;
end;

procedure tglobj.showself;
begin end;

constructor tglsphere.create(aid : smallint;x,y,z,r : single);
begin
inherited create(aid,x,y,z);
radius := r;
end;

function tglsphere.GetSize: single;
begin
getsize := radius;
end;

procedure tglsphere.SetSIze(sz: single);
begin
radius := sz;
end;

procedure tglsphere.showself;
begin
gluSphere(aquadobj,radius,basequal,basequal);
end;

{ tglLight }

constructor tglLight.autocreate(aid: smallint; x, y, z: single);
var i : integer;
j : integer;
begin
j := -1;
for i := 0 to GL_MAX_LIGHTS-1 do
 if not glISenabled(gl_light0+i) then begin j := i;break;end;
 if j = -1 then raise exception.create('TOO MANY LIGHT SOURCES');
glEnable(gl_light0+j);
lnum := j;
modified := true;
glLightfv(gl_light0+lnum,gl_POSITION,@nilfloatar4);
inherited create(aid,x,y,z);
showself;
alwaysredraw := true;
end;

constructor tglLight.create(aid: smallint; x, y, z: single; lightnum: integer);
begin
glEnable(gl_light0+lightnum);
lnum := lightnum;
modified := true;
inherited create(aid,x,y,z);
show;
alwaysredraw := true;
end;
procedure tglLight.setlightparamv(i: integer; var val);
begin
glLightfv(gl_light0+lnum,i,@val);
end;



procedure tglLight.setlightparamf(i: integer; val : single);
begin
glLightf(gl_light0+lnum,i,val);
end;

procedure tglLight.showself;
const lightpos : floatar4 = (0,0,0,1);
lightdir : floatar4 = (0,0,-1,0);
begin
if modified or alwaysredraw then begin
modified := false;
if glcl_DIffuse in uscolor then
 glLightfv(gl_light0+lnum,gl_DIFFUSE,@dif);
if glcl_Ambient in uscolor then
glLightfv(gl_light0+lnum,gl_AMBIENT,@amb);
if glcl_specular in uscolor then
glLightfv(gl_light0+lnum,gl_SPECULAR,@spec);
if refrPOS then glLightfv(gl_light0+lnum,gl_POSITION,@lightpos);
if refrDIR then glLightfv(gl_light0+lnum,gl_spot_direction,@lightDIR);
end;
end;


constructor tglReader.createV(aid: smallint; x, y, z: single;
  data: pointer; datasize: integer);
begin
inherited create(aid,x,y,z);
dsize := datasize;
getmem(datap,dsize);
move(data^,datap^,dsize);
end;

procedure tglLight.setvisibility(val: boolean);
begin
visible := val;
if val then glenable(gl_light0+lnum)
else glDisable(gl_light0+lnum);
end;

{ tglCursor }

procedure tglCursor.broadcast(xc, yc, zc: single; shift: TShiftstate);
var
p : tptrlitem;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
   if (not tglobj(p.ptr).destroyed) and (p.ptr is tglButton) then
   begin
    tglbutton(p.ptr).hclick(xc,yc,zc,shift);
   end;
      p := tptrlitem(p.pn);
 end;
end;

constructor tglCursor.create(aid: smallint; {PANEL DIMEN}aww, awh: integer; AXM,AYM,AZM {RIGHT BOTTOM CORNER}
 : single;ashx,ashy: single;avisu : tglobj);
begin
inherited create(aid,0,0,0);
wh := awh;ww := aww;Mx := axM; My :=ayM;
Mz :=  azm;
shx := ashx;shy := ashy;
rx1 :=0;ry1 := 0;rx2 := ww;ry2 := wh;
visu := avisu;
end;

procedure tglCursor.curmovto(x, y: integer;sh: tshiftstate);
begin
if (RX1 > x) or (RY1 > y) or (RX2 < x) or (RY2 < y) then exit;
xt := (x-ww/2)/ww*mx*2;yt := (wh/2-y)/wh*my*2;
zt := mz;
if visu <> nil then visu.setpos(xt*(1+CHCX),yt*(1+CHCY),zt);
broadcast(xt,yt,zt,sh);
end;

function tglcube.getsize : single;
begin
getsize :=  size;
end;

procedure tglcube.setsize(sz: single);
begin
size := sz*2;
end;

     {G   L }

function extractcolor(color : tcolor;i : integer) : byte;
var
u : array[1..4] of byte absolute color;
begin
extractcolor:= u[i];
end;

constructor tglBitMap.createFromGraphic(aid: smallint; GRPH: TGraphic;AA : byte);
var
x,y : integer;
z : byte;
bmp : tbitmap;
begin
bmp := tbitmap.Create;
bmp.Canvas.Brush.color := clBlack;
bmp.canvas.pen.color := clBlack;
bmp.Height := grph.height;
bmp.width  := grph.width;
bmp.canvas.Draw(0,0,GRPH);
XTL := BMP.Width;
YTL := BMP.Height;
getmem(p,xtl*ytl*4);
for y := 1 to ytl do
 for  x:= 1 to xtl do
 begin
  for z := 1 to 3 do
  byte(incptr(p,((x-1)+(ytl-y)*xtl)*4+z-1)^) := extractcolor(BMP.Canvas.Pixels[x-1,y-1],z);
if BMP.Canvas.Pixels[x-1,y-1]=clBlack then  byte(incptr(p,((x-1)+(ytl-y)*xtl)*4+3)^) := 0
else  byte(incptr(p,((x-1)+(ytl-y)*xtl)*4+3)^) := AA;
end;
bmp.Destroy;
inherited create(aid,0,0,0);
end;

destructor tglBitMap.destroy;
begin
freemem(p);
inherited destroy;
end;

procedure tglBitMap.ResetFromGraphic(GRPH: TGraphic; AA: byte);
var
x,y : integer;
z : byte;
bmp : tbitmap;
begin
freemem(p);
bmp := tbitmap.Create;
bmp.Canvas.Brush.color := clBlack;
bmp.canvas.pen.color := clBlack;
bmp.Height := grph.height;
bmp.width  := grph.width;
bmp.Canvas.Rectangle(1,1,bmp.Width,bmp.height);
bmp.canvas.Draw(0,0,GRPH);
XTL := BMP.Width;
YTL := BMP.Height;
getmem(p,xtl*ytl*4);
for y := 1 to ytl do
 for  x:= 1 to xtl do
 begin
  for z := 1 to 3 do
  byte(incptr(p,((x-1)+(ytl-y)*xtl)*4+z-1)^) := extractcolor(BMP.Canvas.Pixels[x-1,y-1],z);
if BMP.Canvas.Pixels[x-1,y-1]=clBlack then  byte(incptr(p,((x-1)+(ytl-y)*xtl)*4+3)^) := 0
else  byte(incptr(p,((x-1)+(ytl-y)*xtl)*4+3)^) := AA;
end;
bmp.Destroy;
end;

procedure tglBitMap.showself;
begin
glRasterPOs3f(0,0,0);
glDrawpixels(xtl,ytl,gl_RGBA,gl_UNSIGNED_BYTE,p);
end;

procedure tglCursor.show;
begin
{NOTHING!~~~!}
end;

{ tglSafeObj }

procedure tglSafeObj.processlist;
var p,p1 : tptrlitem;
begin
p := tptrlitem(pf.pf);
while p <> nil do
 begin
   if tglobj(p.ptr).destroyed then
   begin
    p1 := P;
    repeat
     p1 := tptrlitem(p1.pn);
     if p1 = nil then break;
    until (p1.id <> p.Id);
    kill(p.id);
    p := p1;
   end
   else
   begin
   (p.ptr as iGLShower).Show;
    p := tptrlitem(p.pn);
   end
 end;
end;

procedure tglFont.charsize(ch: byte; var xsh, ysh: single);
var cp : pointer;
begin
cp := chars[ch];
repeat
case byte(cp^) of
0 : begin xsh := xsh + single1;exit;end;
1 : begin
cp := incptr(cp,2);
end;
2 : begin cp := incptr(cp,1);end;
3 : begin
cp := incptr(cp,13);
end;
4 : begin
cp := incptr(cp,13);
end;
201 : begin
cp := incptr(cp,1);
single1 := single(cp^);{!!!}cp := incptr(cp,4);
end;
end;
until integer(integer(cp)-integer(chars[ch])) > sz;
end;
{$IFDEF OVERLOADS}
procedure tglobj.setcolor(clr: floatar4);
begin
COLORENABLED := true;
color := clr;
end;
{$ENDIF}

{ tglTTString }

constructor tglTTString.create(aid: smallint; x, y, z, xs, ys, zs: single; astr: string;ttf : tglTTFOnt);
begin
inherited create(aid,x,y,z);
str := astr;
xf := xs;yf := ys;zf := zs;
fnt := ttf;
end;

procedure tglTTString.showself;
begin
glPushMatrix;
glScalef(xf,yf,zf);
glListbase(fnt.lbase);
glcalllists(length(str),gl_byte,PCHAR(str));
glFrontFace(gl_CCW);  {they change it}
glPopMatrix;
end;

{ tglTTfont }

constructor tglTTfont.create(aid: smallint; DC: HDC; extr, devi: single;
  hf: HFONT);
begin
inherited create(aid,0,0,0);
selectobject(DC,HF);
lbase := glGenLists(256);
if wglUseFontOutlines(DC ,0,256,lbase,extr,devi,ttstringkind,NIL) then else
raise exception.create('CANT CREATE TT FONT');
end;

destructor tglTTfont.DESTROY;
begin
glDEletelists(lbase,256);
  inherited;
end;

initialization
begin
baseshine := 50;
basequal := 10;
glMaterialfv(glclFace,GL_EMISSION,@ABLACKALPHA);
aquadobj := gluNewQuadric;
  theNURB := gluNewNURBSrenderer;
{     gluNurbsProperty(theNurb, GLU_SAMPLING_TOLERANCE, 200);}
{   glunurbsproperty(theNurb,glu_display_mode,glu_outline_patch);}
   gluNurbsProperty(theNurb, GLU_SAMPLING_METHOD, GLU_DOMAIN_DISTANCE);
    gluNurbsProperty(theNurb, GLU_U_STEP, 4);
    gluNurbsProperty(theNurb, GLU_V_STEP, 4);
end;
end.
