unit glclEffects18;
{                   '
    EEEEEEEEE\      '
    E\\\\\\\\\      '
    EEEEEEEE\       '
    E\\\\\\\\       '
    EEEEEEEEE\      '
    \\\\\\\\\\      '
}
interface
uses glcl18,glclaux18,OpenGL,sysutils,classes,lists;
type
fmatr44 = array[0..3,0..3] of single;

TPointProc = procedure (x,y,z : single) of object;

tglPressButton = class(tglButton)
h,f : single;
clicking : boolean;
clTime   : double;
clStart  : double;
constructor create(aid : smallint;x,y,z,axb,ayb,azb : single;what : TNotifyEvent;height,faska : single);
procedure showself;override;
procedure press;virtual;
end;

tglDynaString = class(tglString)
verts,lverts,wverts,tverts : integer;
sttime : double;
atime : double;
aborted : boolean;
state : (dsApp,dsStatic,dsDisApp);
onVertex : tpointproc;                                                        {time to show}
constructor create(aid : smallint;x,y,z : single;astr : string;afnt : tglFont;aptime : single);
function vertexes : integer;virtual;
procedure write(ch : byte;var xsh,ysh : single);virtual;
procedure writestr;virtual;
procedure showself;override;
procedure disappear;virtual;
end;

tP3dLItem = class(tlitem)
x,y,z : single;
constructor create(aid  : smallint;ax,ay,az : single);
end;

tRWLine = class(tp3dlitem)
dstr : tglobj;
constructor create(aid : smallint;adstr : tglobj);
procedure onvertex(ax,ay,az : single);virtual;
end;

tglRayWriter = class(tglobj) {effect on tglDynaString}
lt : tOrderedlist;
constructor create(aid: smallint;x,y,z : single);
procedure use(dstr : tglobj{supposed as tdynastring});virtual;
procedure unuse(dstr : tglobj);virtual;
procedure unuseAll;virtual;
procedure showself;override;
destructor destroy;override;
end;

tglIonLetters = class(tglObj)
lt : tOrderedlist;
atm : double;
h   : single;                                                  {Ion Flight Height}
constructor create(aid : smallint;x,y,z : single;atime : double;zh : single);
procedure use(dstr : tglobj{supposed as tdynastring});virtual;
procedure onvertex(x,y,z : single);virtual;
procedure showself;override;
destructor destroy;override;
end;

tglNURBSMorph = class(tglNURBSCurve)
morphing,loop : boolean;
starttime,morphtime : extended;
constructor create(aid : smallint;x,y,z : smallint;ms,mt : byte);
procedure startmorph(EACHMORPHTIME : DOUBLE;looped : boolean);virtual;
procedure show;override;
{destructor destroy;override;}
end;

tglANYMatrix = class(tglobj)
r : single;
matr : fmatr44;
constructor create(aid : smallint;range : single);
procedure show;override;
end;

tglLightingLine = class(tglobj)
lx,ly,lz,k : single;
ss : integer;
constructor create(aid : smallint;x,y,z : single;alx,aly,alz : single;ak : single;s : integer);
procedure showself;override;
end;

tglExplosion = class(tglobj)
totime,sttime : double;
constructor create(aid : smallint;x,y,z,r,g,b,u,rad : single;atime : double);
procedure show;override;
end;

tglFlame = class(tglobj)
unts : integer;
s : single;
toobj : tglobj;
lastcall,rtime,flytime : double;
flylen : single;
attach : tglobj;
constructor create(aid : smallint;x,y,z,a : single;radtime : double;linkto : tglobj);
procedure show;override;
procedure showself;override;
procedure setcolor(r,g,b,a : single);override;
end;

tglStarsPlane = class(tglobj)
sn : integer;
xrn,yrn : single;
sp : pointer;
constructor create(aid : smallint;x,y,z : single;starsnum : integer;xrange,yrange : single);
procedure showself;override;
destructor destroy;override;
end;

tglDust = class(tglStarsplane)
zrn : single;
constructor create(aid : smallint;x,y,z : single;starsnum : integer;xrange,yrange,zrange : single);
procedure showself;override;
destructor destroy;override;
end;

tglComet = class(tglVmover)
rad : single;
kper : tglobj;
constructor Create(aid : smallint;x,y,z,r : single;keeper : tglobj);
procedure setcolor(r,g,b,a : single);override;
procedure showself;override;
procedure killall;override;
end;

tglExpComet = class(tglcomet)
procedure killall;override;
end;

tglBevelRect = class(tglList)
f,h : single;
wx,wy : single;
constructor create(aid : smallint;x,y,z : single;Awx,Awy : single;Faska,Hght: single);
procedure showself2;override;
end;

procedure xglBevelRect(wx,wy,f,h : single);

implementation
procedure tglExpComet.killall;
var
i : integer;
an1,an2 : single;
vx1,vy1,vz1,u1 : single;
cm : tglcomet;
matr : array[0..3,0..3] of single;
begin
if not kper.destroyed then
begin
glPushMatrix;
u1 := sqrt(zm*zm + ym*ym + xm*xm);
for i := 1 to 8 do
 begin
 glLoadIdentity;
 an1 := random(360);
 an2 := random(360);
 glROtatef(an1,1,0,0);
 glROtatef(an2,0,1,0);
 glTranslatef(0,0,u1);
 glGetFloatv(gl_modelview_MAtrix,@matr);
 vz1 := matr[3,2];
 vx1 := matr[3,0];
 vy1 := matr[3,1];
 cm := tglcomet.create(getfreeaddr(kper,4000),xt,yt,zt,rad*0.5,kper);
 cm.setcolor(color[0],color[1],color[2],color[3]);
 cm.setrotate(an1,an2+180,0);
 cm.startmove(vx1,vy1,vz1,0,0,0,movetime/2);
 kper.add(cm);
 end;
 glPopMatrix;
 end;
inherited killall;
end;

procedure tglcomet.setcolor(r,g,b,a : single);
begin
inherited setcolor(r,g,b,a);
tglOBj(find(1)).color := color;
end;

constructor tglcomet.Create(aid : smallint;x,y,z,r : single;keeper : tglobj);
var fl : tglflame;
begin
inherited create(aid,x,y,z);
if keeper = nil then keeper := self;
kper := keeper;
rad := r;
uscolor := [glcl_AMBIENT]+[glcl_DIFFUSE]+[GLCL_SPECULAR];
fl := tglflame.create(1,0,0,0,r,0.05*sec,keeper);
fl.unts := 10;
fl.flytime := 0.9*sec;
fl.flylen  := r*2;
fl.attach := self;
add(fl);
visible := true;
autodestroy := true;
end;

{WHY NOT??}
procedure tglcomet.showself;
begin
glMAteriaLFV(glclFace,gl_AMBIENT_AND_DIFFUSE,@color);
glMAteriaLFV(glclFace,gl_SPECULaR,@color);
glUsphere(aquadobj,rad,basequal,basequal);
{glMAteriaLFV(glclFace,gl_EMISSION,@ABLACKALPHA);}
end;

procedure tglCOmet.killall;
var
exp : tglexplosion;
BEGIN
if not kper.destroyed then begin
exp := tglexplosion.create(getfreeaddr(kper,4000),xt,yt,zt,color[0],color[1],
color[2],color[3],rad*3,0.5*sec);
kper.add(exp);                  end;
inherited killall;
END;

constructor tglStarsPlane.create(aid : smallint;x,y,z : single;starsnum : integer;xrange,yrange : single);
var
d : ^single;
e : integer;
begin
inherited create(aid,x,y,z);
sn := starsnum;
xrn := xrange;yrn := yrange;
getmem(sp,starsnum*8);
uscolor := [];
for e := 1 to sn do
begin
d := pointer(integer(sp)+(e-1)*8);
d^ := xrn*(random(100)/100-0.5);
d := pointer(integer(sp)+(e-1)*8+4);
d^ := yrn*(random(100)/100-0.5);
end;
end;

procedure tglSTARSPLANE.showself;
var e : integer;
xtt,ytt : single;
d : ^single;
begin
glPointsize(1);
glMaterialfv(glclFace,GL_EMISSION,@COLOR);
glBegin(GL_POINTS);
for e := 1 to sn do
begin
d := pointer(integer(sp)+(e-1)*8);
xtt := d^;
d := pointer(integer(sp)+(e-1)*8+4);
ytt := d^ ;
glVertex3f(xtt,ytt,0);
end;
glend;
glMaterialfv(glclFace,GL_EMISSION,@ABLACKALPHA);
end;

procedure tglflame.setcolor(r,g,b,a : single);
begin
inherited setcolor(r,g,b,a);
end;

constructor tglFlame.create(aid : smallint;x,y,z,a : single;radtime : double;linkto : tglobj);
begin
inherited create(aid,x,y,z);
s := a; toobj := linkto;
if toobj = nil then toobj := self;
lastcall := curtime; rtime := radtime;
unts := 3;
colorenabled := true;
uscolor := [];
flytime := rtime*4;
flylen := s*10;
attach := nil;
end;

procedure tglflame.showself;
begin
glMaterialfv(glclFace,gl_EMISSION,@COLOR);
gludisk(aquadobj,0,s,basequal,2);
glMaterialfv(glclFace,gl_EMISSION,@ABLACKALPHA);
end;

procedure tglFlame.show;{DEFINE FREE ADRESS SPACE ON 4000}
var u,e : tglobj;
i : integer;
xx,yy,rr,a  : single;
begin
if (curtime - lastcall> rtime) then
begin
e := tglemifader.create(getfreeaddr(toobj,4000),color[0]*(1.2-random(40)/100),color[1]*(1.2-random(40)/100),color[2]*(1.2-random(40)/100),color[3],flytime);
if attach <> nil then begin e.setpos(attach.xt,attach.yt,attach.zt);
e.setrotate(attach.xr,attach.yr,attach.zr); end;
{e.setrotate(00,00,00);}
tglemifader(e).low := 0.3;
toobj.add(e);
for i := 1 to unts do
begin
rr := random(100)/100*s;
a := random(360)*pi180;
xx := rr*cos(a);
yy := rr*sin(a);
u := tglSpeedPoint.create(i{ADRESS SPACE},xx+xt,yy+yt,0+zt,s/2);
tglmover(u).startmove(0,0,flylen*(s-rr)/s,0,0,0,flytime);
e.Add(u);
lastcall := curtime;
end;
end;
beginshow;
showself;
endshow;
end;


constructor tglexplosion.create(aid : smallint;x,y,z,r,g,b,u,rad : single;atime : double);
var
xi : integer;
emf,mv : tglobj;
xy,zz,ang,xx,yy : single;
rad1 : single;
begin
inherited create(aid,x,y,z);
totime := atime;
sttime := curtime;
emf := tglemifader.create(200,r,g,b,u,atime);
tglemifader(emf).low := 0.4;
add(emf);
for xi := 1 to 60 do
begin
{tr := tglpoint.create(xi,0,0,0,0);{,rad/25}
{tr.setcolor(0,0,0,1);}
mv := tglSpeedPoint.create(xi,rad*(random(50)/200-0.125),rad*(random(50)/200-0.125),rad*(random(50)/200-0.125),5);
rad1 := rad*(1-random(50)/100);
ang := random(360)*pi180;
zz := sin(ang)*rad1;
xy := cos(ang)*rad1;
ang :=random(360)*pi180;
xx := xy*sin(ang);
yy := xy*cos(ang);
tglmover(mv).startmove(xx,yy,zz,0,0,0,atime);
emf.add(mv);
end;
end;


procedure tglexplosion.show;
begin
if (curtime-sttime >totime) then destroyed := true;
glpointsize(3);
inherited show;
end;

constructor tglNURBSMorph.create(aid : smallint;x,y,z : smallint;ms,mt : byte);
var pp : pointer;
begin
getmem(pp,mt*ms*4*3);
inherited create(aid,x,y,z,ms,mt,pp);
freemem(pp,mt*ms*4*3);
morphing := false;
end;
procedure tglNurbsMorph.startmorph(EACHMORPHTIME : DOUBLE;looped : boolean);
begin
loop := looped;
starttime := curtime;
morphtime := eachmorphtime;
morphing := true;
end;

procedure tglNurbsMorph.show;
var curmorph,x,y,z,oofs : integer;
curm,nextm : tglNurbsCurve;
ps : double;
val : single;
p : ^single;
u : extended;
procedure setsingle(ps : pointer;ofss : integer;val : single);
begin p := ptr(integer(ps)+ofss*4); p^ := val;
end;
function getsingle(ps : pointer;ofss : integer) : single;
begin p := ptr(integer(ps)+ofss*4); getsingle := p^; end;

begin
if not morphing then curmorph := 1 else
begin
u := (curtime - starttime)/morphtime;
if morphtime = 0 then curmorph := 1 else curmorph := trunc(u)+1;
if curmorph > pf.count-1 then if loop then begin
starttime := curtime;curmorpH := 1;
u := 0;
end else curmorph := pf.count-1;
end;
curm := tglNurbsCurve(find(curmorph));
if curm = nil then exit;
nextm := tglNurbsCurve(find(curmorph+1));
glPushMatrix;
gltranslatef(xt,yt,zt);
if xr <> 0 then glrotatef(xr,1,0,0);
if yr <> 0 then glrotatef(yr,0,1,0);
if zr <> 0 then glrotatef(zr,0,0,1);
if colorenabled then begin
if glcl_AMBIENT IN USCOLOR then glmaterialfv(glclFace,GL_AMBIENT,@color)
else glmaterialfv(glclFace,GL_AMBIENT,@ABLACKALPHA) ;
if glcl_SPECULAR IN USCOLOR then begin
glmaterialfv(glclFace,GL_SPECULAR,@color);
glmaterialf(glclFace,GL_SHININESS,baseshine);
end else glmaterialfv(glclFace,GL_SPECULAR,@AblackALPHA);
if glcl_DIFFUSE IN USCOLOR then glmaterialfv(glclFace,GL_DIFFUSE,@color)
else glmaterialfv(glclFace,GL_DIFFUSE,@AblackALPHA);
if enhcolor <> nil then
begin
enhcolor.SHOW;
end;
end;

if (not morphing) or (nextm = nil) then begin
curm.show;
glPopMatrix;
end else
begin
if (curm.maxs <> nextm.maxs) or (curm.maxt <> nextm.maxt) then exit;
ps := u - curmorph+1;
if ps > 1 then ps := 1;
if ps < 0 then ps := 1;
for x := 0 to mAXs-1 do
 for y := 0 to mAXt-1 do
  for z := 0 to 2 do
  begin
  oofs := x*mAXT*3+y*3+z;
  val := getsingle(curm.curvep,oofs);
  val := val + ps*(getsingle(nextm.curvep,oofs)-val);
  SETSINGLE(CURVEP,OOFS,VAL);
  end;
  SHOWSELF;
  glPopMatrix;
end;
end;

{ tglANYMatrix }

constructor tglANYMatrix.create(aid: smallint; range: single);
var i,j : byte;
begin
inherited create(aid,0,0,0);
r := range;
for i := 0 to 3 do for j := 0 to 3 do matr[i,j] := 0;
for i := 0 to 3 do matr[i,i] := 1;
end;


procedure tglANYMatrix.show;
var i,j : byte;
begin
glPushmatrix;
for i := 0 to 2 do
{ for j := 0 to 2 do
 matr[i,j] := matr[i,j]+(random(100)/50-1)*r;}
 matr[3,3] := matr[3,3]+(random(100)/50-1)*r;
glMultMatrixf(@matr[0,0]);
processlist;
glPopmatrix;
end;

{ tglDust }

constructor tglDust.create(aid: smallint; x, y, z: single;
  starsnum: integer; xrange, yrange, zrange: single);
var
d : ^single;
e : integer;
begin
inherited create(aid,x,y,z,1,xrange,yrange);
freemem(sp);
sn := starsnum;
zrn := zrange;
getmem(sp,starsnum*12);
uscolor := [];
for e := 1 to sn do
begin
d := pointer(integer(sp)+(e-1)*12);
d^ := xrn*(random(100)/100-0.5);
d := pointer(integer(sp)+(e-1)*12+4);
d^ := yrn*(random(100)/100-0.5);
d := pointer(integer(sp)+(e-1)*12+8);
d^ := zrn*(random(100)/100-0.5);
end;
end;

destructor tglDust.destroy;
begin
freemem(sp,sn*12);
getmem(sp,sn*8);
inherited destroy;
end;


procedure tglDust.showself;
var e : integer;
xtt,ytt,ztt : single;
d : ^single;
begin
glPointsize(2);
glNormal3f(0,0,1);
glBegin(GL_POINTS);
for e := 1 to sn do
begin
d := pointer(integer(sp)+(e-1)*12);
xtt := d^;
d := pointer(integer(sp)+(e-1)*12+4);
ytt := d^ ;
d := pointer(integer(sp)+(e-1)*12+8);
ztt := d^ ;
glVertex3f(xtt,ytt,ztt);
end;
glend;
end;

destructor tglStarsPlane.destroy;
begin
freemem(sp,sn*8);
inherited destroy;
end;


{ tglLightingLine }

constructor tglLightingLine.create(aid: smallint; x, y, z, alx, aly,
  alz: single;ak : single;s : integer);
begin
lx := alx;ly := aly;lz := alz;k := ak;ss := s;
inherited create(aid,x,y,z);
end;

procedure tglLightingLine.showself;
var i : integer;
begin
glBegin(gl_Line_Strip);
glNormal3f(0,0,1);
glVertex3f(0,0,0);
for i := 1 to ss-1 do
glVertex3f(lx*i/ss+(random-0.5)*k,ly*i/ss+(random-0.5)*k,lz*i/ss+(random-0.5)*k);
glVertex3f(lx,ly,lz);
glEnd;
end;

procedure xglLeaf(len : single;sl : integer;stf,ef{Phase in radins} : single;
wid : single;stang{start angle},endang{end angle } : single);
var
curang,ph : single;
cx,cz : single;
i : integer;
begin
cx := 0;cz := 0;
glBegin(gl_Quad_Strip);
for i := 0 to sl do
begin
curang := stang+(endang-stang)/sl*i;
glNormal3f(-cos(curang+pi/2),0,-sin(curang+pi/2));
ph := stf + (ef-stf)/sl*i;
glVertex3f(cx,-wid*abs(sin(ph)),cz);
glVertex3f(cx,wid*abs(sin(ph)),cz);
cx := cx+cos(curang)*len/sl;
cz := cz+sin(curang)*len/sl;
end;
glEnd;
cx := 0;cz := 0;
glBegin(gl_Quad_Strip);
for i := 0 to sl do
begin
curang := stang+(endang-stang)/sl*i;
glNormal3f(cos(curang+pi/2),0,sin(curang+pi/2));
ph := stf + (ef-stf)/sl*i;
glVertex3f(cx,wid*abs(sin(ph)),cz);
glVertex3f(cx,-wid*abs(sin(ph)),cz);
cx := cx+cos(curang)*len/sl;
cz := cz+sin(curang)*len/sl;
end;
glEnd;
end;

procedure xglRLeaf(len : single;sl : integer;stf,ef{Phase in radins} : single;
wid : single;stang{start angle},endang{end angle } : single;esh : single{shift of mid part});
var
curang,ph : single;
cx,cz : single;
i : integer;
lne : single;
begin
cx := 0;cz := 0;
lne := sqrt(sqr(esh)+sqr(wid));
glBegin(gl_Quad_Strip);
for i := 0 to sl do
begin
curang := stang+(endang-stang)/sl*i;
ph := stf + (ef-stf)/sl*i;
glNormal3f(-cos(curang+pi/2),sin(curang+pi/2)*esh/lne,-sin(curang+pi/2)*wid/lne);
glVertex3f(cx-cos(curang+pi/2)*esh,-wid*abs(sin(ph)),cz-sin(curang+pi/2)*esh);
glNormal3f(-cos(curang+pi/2),0,-sin(curang+pi/2));
glVertex3f(cx,0,cz);
cx := cx+cos(curang)*len/sl;
cz := cz+sin(curang)*len/sl;
end;
glEnd;
cx := 0;cz := 0;
glBegin(gl_Quad_Strip);
for i := 0 to sl do
begin
curang := stang+(endang-stang)/sl*i;
ph := stf + (ef-stf)/sl*i;
glNormal3f(-cos(curang+pi/2),0,-sin(curang+pi/2));
glVertex3f(cx,0,cz);
glNormal3f(-cos(curang+pi/2),-sin(curang+pi/2)*esh/lne,-sin(curang+pi/2)*wid/lne);
glVertex3f(cx-cos(curang+pi/2)*esh,wid*abs(sin(ph)),cz-sin(curang+pi/2)*esh);
cx := cx+cos(curang)*len/sl;
cz := cz+sin(curang)*len/sl;
end;
glEnd;
cx := 0;cz := 0;
glBegin(gl_Quad_Strip);
for i := 0 to sl do
begin
curang := stang+(endang-stang)/sl*i;
ph := stf + (ef-stf)/sl*i;
glNormal3f(cos(curang+pi/2),0,sin(curang+pi/2));
glVertex3f(cx,0,cz);
glNormal3f(cos(curang+pi/2),-sin(curang+pi/2)*esh/lne,sin(curang+pi/2)*wid/lne);
glVertex3f(cx-cos(curang+pi/2)*esh,-wid*abs(sin(ph)),cz-sin(curang+pi/2)*esh);
cx := cx+cos(curang)*len/sl;
cz := cz+sin(curang)*len/sl;
end;
glEnd;
cx := 0;cz := 0;
glBegin(gl_Quad_Strip);
for i := 0 to sl do
begin
curang := stang+(endang-stang)/sl*i;
ph := stf + (ef-stf)/sl*i;
glNormal3f(cos(curang+pi/2),sin(curang+pi/2)*esh/lne,sin(curang+pi/2)*wid/lne);
glVertex3f(cx-cos(curang+pi/2)*esh,wid*abs(sin(ph)),cz-sin(curang+pi/2)*esh);
glNormal3f(cos(curang+pi/2),0,sin(curang+pi/2));
glVertex3f(cx,0,cz);
cx := cx+cos(curang)*len/sl;
cz := cz+sin(curang)*len/sl;
end;
glEnd;
end;

{ tglApearString }

constructor tglDynaString.create(aid: smallint; x, y, z: single;
  astr: string; afnt: tglFont; aptime: single);
begin
sttime := curtime;
atime := aptime;
lverts := 0;state := dsApp;
inherited create(aid,x,y,z,astr,afnt);
verts := vertexes;
end;

procedure tglDynaString.disappear;
begin
sttime := now;
tverts := vertexes;
state := dsDIsapp;
end;

procedure tglDynaString.showself;
var dt : double;
begin
case state of
dsAPP : begin
        dt := curtime - sttime;
        if dt > atime then state :=dsStATIC;
        tverts := round(verts*dt/atime);
        if tverts > verts then tverts := verts;
        writestr;
        end;
dsStatic :  inherited;
dsDisApp : begin
          dt := curtime - sttime;
          if dt > atime then destroyed := true;
         lverts := verts-trunc(verts*dt/atime);
        if lverts <0 then lverts := 0;
        writestr;
        end;{UNIMPLEMENTED}
end;
end;

function tglDynaString.vertexes: integer;
var i : integer;
vert : integer;
cp : POINTER;
begin
vert := 0;
for i := 1 to length(fst) do begin
cp := fnt.chars[byte(fst[i])];
repeat
case byte(cp^) of
0 : break;
1 : cp := incptr(cp,2);
2 : cp := incptr(cp,1);
3 : begin inc(vert);cp := incptr(cp,13);end;
4 : cp := incptr(cp,13);
201 : cp := incptr(cp,5);
end;
until integer(integer(cp)-integer(fnt.chars[byte(fst[i])])) > fnt.sz;
end;
result := vert;
end;

procedure tglDynaString.write(ch : byte;var xsh,ysh : single);
var cp : pointer;
x,y,z : single;
begin
if (tverts = wverts) then BEGIN ABORTED := TRUE;EXIT;END;
cp := fnt.chars[ch];
repeat
case byte(cp^) of
0 : begin if fnt.autoshift then xsh := xsh + single1;exit;end;
1 : begin
cp := incptr(cp,1);
if (state = dsAPP) or (wverts < lverts) then glbegin(byte(cp^));
cp := incptr(cp,1);
end;
2 : begin if (state = dsAPP) or (wverts < lverts) then glENd;cp := incptr(cp,1);end;
3 : begin
cp := incptr(cp,1);
x := single(cp^);{!!!}cp := incptr(cp,4);
y := single(cp^);{!!!}cp := incptr(cp,4);
z := single(cp^);{!!!}cp := incptr(cp,4);
inc(wverts);
if (state = dsAPP) or (wverts <= lverts) then glVertex3f((x+xsh)*fnt.xt,(y+ysh)*fnt.yt,z*fnt.zt);
if (state = dsDisapp) and (wverts=lverts) then glEnd;
if (wverts > lverts) then if assigned(onVertex) then onVertex((x+xsh)*fnt.xt+xt,(y+ysh)*fnt.yt+yt,z*fnt.zt+zt);
if (wverts = tverts) then begin
if state <> dsdISAPP then glEnd;
aborted := true;exit end;
end;
4 : begin
cp := incptr(cp,1);
x := single(cp^);{!!!}cp := incptr(cp,4);
y := single(cp^);{!!!}cp := incptr(cp,4);
z := single(cp^);{!!!}cp := incptr(cp,4);
glNormal3f(x,y,z);
end;
201 : begin
cp := incptr(cp,1);
single1 := single(cp^);{!!!}cp := incptr(cp,4);
end;
end;
until integer(integer(cp)-integer(fnt.chars[ch])) > fnt.sz;
end;

procedure tglDynaString.writestr;
var x : integer;
shx,shy : single;
begin
aborted := false;
wverts := 0;
maxxsh := 0;
maxysh := 0;
glNormal3f(0,0,1);{default}
shx := 0;shy := 0;
fnt.xt := xf;fnt.yt := yf;
for x := 1 to length(fst) do
begin
if shy > maxysh then maxysh := shy;
if shx > maxxsh then maxxsh := shx;
if fst[x] = #$D then begin  shx := 0;continue end;   {CR}
if fst[x] = #$A then begin shy := shy-1;continue;end;{LF}
write(byte(fst[x]),shx,shy);
if not fnt.autoshift then shx := shx+xf;
if aborted then break;
end;
if state = dsApp then lverts := wverts
else tverts := lverts;
if shy > maxysh then maxysh := shy;
if shx > maxxsh then maxxsh := shx;
maxxsh := maxxsh*xf;
maxysh := maxysh*yf;
end;

{ tglRayWriter }

constructor tglRayWriter.create(aid: smallint; x, y, z: single);
begin
inherited create(aid,x,y,z);
lt := tOrderedList.create(0);
end;

destructor tglRayWriter.destroy;
begin
lt.free;
  inherited;
end;


procedure tglRayWriter.showself;
var p : tP3dlitem;
stpl : word;
begin
if lt.count = 0 then exit;
glPushAttrib(gl_line_BIT);
glEnable(gl_line_stipple);
glLineWidth(1);
stpl := random(65536);
glLinestipple(1,stpl);
glBegin(gl_LInes);
glNormal3f(0,0,0);{EMISSION AND AMBIENT COLORS ONLY RECOMENDED}
p := tRWLine(lt.pf);
while p <> nil do begin
glVertex3f(0,0,0);
glVertex3f(p.x-xt,p.y-yt,p.z-zt);
p := tP3dlitem(p.pn);
end;
glEnd;
glPopAttrib;
end;

procedure tglRayWriter.unuse(dstr: tglobj);
var pp : tlitem;
begin
pp := lt.Pf;
while pp <> nil do
begin
if tRWLine(pp).dstr = dstr then begin lt.kill(pp.id);exit;end;
pp := pp.pn;
end;
end;

procedure tglRayWriter.unuseAll;
begin
lt.killall;
end;

procedure tglRayWriter.use(dstr: tglobj);
var pp : tRWLine;
begin
if dstr is tglDynaString then begin
pp := tRWLine.create(lt.count+1,dstr);
lt.add(pp);
(dstr as tglDynaString).onVertex := pp.onvertex;
end;
end;

{ tP3dLItem }

constructor tP3dLItem.create(aid: smallint; ax, ay, az: single);
begin
inherited create(aid);
x := ax;y := ay;z := az;
end;

{ tglIonLetters }

constructor tglIonLetters.create(aid: smallint; x, y, z: single;
  atime: double; zh: single);
begin
inherited create(aid,x,y,z);
atm := atime;h := zh;
lt := torderedlist.create(0);
end;

destructor tglIonLetters.destroy;
begin
lt.free;
inherited destroy;
end;

procedure tglIonLetters.onvertex(x, y, z: single);
begin
lt.add(tP3dlitem.create(lt.count+1,x,y,z));
end;

procedure tglIonLetters.showself;
var p : tP3dlitem;
em : tglEmiFader;
sp : tglSpeedPoint;
begin
if lt.count = 0 then exit;
em := tglEmiFader.create(getfid(self),color[0],color[1],color[2],color[3],atm);
add(em);
em.low := 0.3;
p := tP3dlitem(lt.pf);
while p <> nil do begin
sp := tglSpeedPoint.create(em.count+1,p.x,p.y,p.z,2);
sp.startmove(0,0,h,0,0,0,atm);
em.add(sp);
p := tP3dlitem(p.pn);
end;
lt.killall;
end;

procedure tglIonLetters.use(dstr: tglobj);
begin
(dstr as tgldynastring).onvertex := onvertex;
end;

{ tglPressButton }

constructor tglPressButton.create(aid: smallint; x, y, z, axb, ayb,
  azb: single; what: TNotifyEvent; height, faska: single);
begin
inherited create(aid,x,y,z,axb,ayb,azb,what);
h := height;f := faska;
clTime := 0.2*sec;
end;

procedure tglPressButton.press;
var jm : tglJumper;
begin
if clicking then exit;
jm := tglJumper.create(getfid(self),0,0,0);
add(jm);
jm.autodestroy := true;
jm.addp(self);
jm.startmove(0,0,0,0,0,0,clTime);
jm.startjump(0,0,-h);
clStart := curtime;
clicking := true;
end;

procedure xglBevelRect(wx,wy,f,h : single);
var nz,nu : single;
begin
nu := sqrt(sqr(F)+sqr(h));
nz := f/nu;
nu := h/nu;
glBegin(gl_quads);
{FACE}
glNormal3f(0,0,1);
glVertex3f(f,wy-f,h);
glVertex3f(f,f,h);
glVertex3f(wx-f,f,h);
glVertex3f(wx-f,wy-f,h);
{Bottom}
glNormal3f(0,-nu,nz);
glVertex3f(0,0,0);
glVertex3f(wx,0,0);
glVertex3f(wx-f,f,h);
glVertex3f(f,f,h);
{top}
glNormal3f(0,nu,nz);
glVertex3f(wx,wy,0);
glVertex3f(0,wy,0);
glVertex3f(f,wy-f,h);
glVertex3f(wx-f,wy-f,h);
{left}
glNormal3f(-nu,0,nz);
glVertex3f(0,wy,0);
glVertex3f(0,0,0);
glVertex3f(f,f,h);
glVertex3f(f,wy-f,h);
{right}
glNormal3f(nu,0,nz);
glVertex3f(wx,0,0);
glVertex3f(wx,wy,0);
glVertex3f(wx-f,wy-f,h);
glVertex3f(wx-f,f,h);
glEnd;
end;

procedure tglPressButton.showself;
begin
if clicking then if curtime - clStart > clTIme then clicking := false;
xglBevelRect(xb-xt,yb-yt,f,h);
end;

{ tglBevelRect }

constructor tglBevelRect.create(aid: smallint; x, y, z,AWX,AWY,Faska,
  Hght: single);
begin
f := faska;h := hght;
wx := awx;wy := awy;
inherited create(aid,x,y,z);
end;

procedure tglBevelRect.showself2;
begin
xglbevelRect(wx,wy,f,h);
end;

{ tRWLine }

constructor tRWLine.create(aid: smallint; adstr: tglobj);
begin
inherited create(aid,0,0,0);
dstr := adstr;
end;

procedure tRWLine.onvertex(ax, ay, az: single);
begin
x := ax;y := ay;z := az;
end;

end.
