unit glclMaterials18;

interface
uses glcl18,sysutils;
type
tglFunnyMarble = class(tglTexture)
constructor create(aid : smallint);
end;

tglRustySilver = class(tglTexture)
constructor create(aid : smallint);
end;

tglPlasmatic = class(tglTexture)
constructor create(aid : smallint;r,g,b,a : single);
end;
tglTexLoader = class(tglTexture)
constructor create(aid : smallint;fname : string);
end;

tglGranite = class(tglTexture)
constructor create(aid : smallint);
end;

tglEternium = class(tglenhcol)
constructor create(aid : smallint);
end;

implementation


constructor tglEternium.create(aid : smallint);
begin
inherited create(aid,0,0,0);
 setEnhCOl([glcl_AMBIENT],0.1,0.1,0.1,1);
 setEnhCOl([glcl_DIFFUSE],0.7,0.7,0.7,1);
 setEnhCOl([glcl_SPECULAR],0.7,0.7,0.75,1);
 shine := 80;
end;

constructor tglGranite.create(aid : smallint);
var
x,y : integer;
image : array[1..64,1..64] of color4b;
begin
for x := 1 to 64 do
 for y := 1 to 64 do
 begin
 image[x,y,4] := 255;
 case random(4) of
 0 :  begin image[x,y,1] := 110; image[x,y,2] := 60; image[x,y,3] := 40;end;
 1 :   if random(2) = 1 then begin
 image[x,y,1] := 250;
 image[x,y,2] := 250;
 image[x,y,3] := 250;
 end else begin
 image[x,y,1] := 110;
 image[x,y,2] := 60;
 image[x,y,3] := 40;
 end;

 2 :   begin
 image[x,y,1] := 50;
 image[x,y,2] := 50;
 image[x,y,3] := 50;
 end;
3 :   begin
 image[x,y,1] := 130;
 image[x,y,2] := 80;
 image[x,y,3] := 60;
 end;

 end;
 end;
 inherited create(aid,64,64,@image);
 setEnhCOl([glcl_AMBIENT],1,1,1,1);
 setEnhCOl([glcl_DIFFUSE],0.7,0.75,0.7,1);
 setEnhCOl([glcl_SPECULAR],0.1,0.1,0.15,1);
 shine := 80;
end;


constructor tglPlasmatic.create(aid : smallint;r,g,b,a : single);
var
x,y : integer;
image : array[1..64,1..64] of color4b;
r1,g1,b1,a1 : integer;
begin
image[1,1,1] := round(r*255); image[1,1,2] := round(g*255); image[1,1,3] := round(b*255);image[1,1,4] := round(a*255);
for x := 2 to 32 do
begin
r1 := image[x-1,1,1] + random(41)-20;
g1 := image[x-1,1,2] + random(41)-20;
b1 := image[x-1,1,3] + random(41)-20;
a1 := image[x-1,1,4] + random(41)-20;
if r1 > 255 then r1 := 255; if r1 <0 then r1 := 0;
if g1 > 255 then g1 := 255; if g1 <0 then g1 := 0;
if b1 > 255 then b1 := 255; if b1 <0 then b1 := 0;
if a1 > 255 then a1 := 255; if a1 <0 then a1 := 0;
image[x,1,1] := r1;image[x,1,2] := g1;image[x,1,3] := b1;image[x,1,4] := a1;
r1 := image[1,x-1,1] + random(41)-20;
g1 := image[1,x-1,2] + random(41)-20;
b1 := image[1,x-1,3] + random(41)-20;
a1 := image[1,x-1,4] + random(41)-20;
if r1 > 255 then r1 := 255; if r1 <0 then r1 := 0;
if g1 > 255 then g1 := 255; if g1 <0 then g1 := 0;
if b1 > 255 then b1 := 255; if b1 <0 then b1 := 0;
if a1 > 255 then a1 := 255; if a1 <0 then a1 := 0;
image[1,x,1] := r1;image[1,x,2] := g1;image[1,x,3] := b1;image[1,x,4] := a1;
end;

for x := 2 to 32 do
for y := 2 to 32 do
begin
r1 := (image[x-1,y-1,1]+image[x-1,y,1]+image[x,y-1,1]) div 3 + random(41)-20;
g1 := (image[x-1,y-1,2]+image[x-1,y,2]+image[x,y-1,2]) div 3 + random(41)-20;
b1 := (image[x-1,y-1,3]+image[x-1,y,3]+image[x,y-1,3]) div 3 + random(41)-20;
a1 := (image[x-1,y-1,4]+image[x-1,y,4]+image[x,y-1,4]) div 3 + random(41)-20;
if r1 > 255 then r1 := 255; if r1 <0 then r1 := 0;
if g1 > 255 then g1 := 255; if g1 <0 then g1 := 0;
if b1 > 255 then b1 := 255; if b1 <0 then b1 := 0;
if a1 > 255 then a1 := 255; if a1 <0 then a1 := 0;
image[x,y,1] := r1;image[x,y,2] := g1;image[x,y,3] := b1;image[x,y,4] := a1;
end;

for x := 33 to 64 do
 for y := 1 to 32 do
 begin
 image[x,y] := image[65-x,y];
 end;
 for x := 1 to 64 do
 for y := 33 to 64 do
 begin
 image[x,y] := image[x,65-y];
 end;


 inherited create(aid,64,64,@image);
 setEnhCOl([glcl_AMBIENT],r,g,b,a);
 setEnhCOl([glcl_DIFFUSE],r,g,b,a);
 setEnhCOl([glcl_SPECULAR],r/3,g/3,b/3,a);
{ setEnhCOl([glcl_EMISSION],r,g,b,a);}
shine := 50;
end;

constructor tglTexLoader.create(aid : smallint;fname : string);
var
x,y,z : integer;
image : array[1..64,1..64] of color4b;
f : file of byte;
begin
if fileexists(fname) then
begin
assignfile(f,fname);
reset(f);
for x := 1 to 64 do
 for y := 1 to 64 do
  for z := 1 to 4 do
  read(f,image[x,y,z]);
 inherited create(aid,64,64,@image);
 setEnhCOl([glcl_AMBIENT],0.5,0.5,0.5,1);
 setEnhCOl([glcl_DIFFUSE],0.7,0.7,0.7,1);
 setEnhCOl([glcl_SPECULAR],0.5,0.5,0.5,1);;
 shine := 110;
 end
 else
 begin
 raise exception.create('TEXTURE FILE DOESN''T EXIST');
 end;
end;


constructor tglRustySilver.create(aid : smallint);
var
x,y : integer;
image : array[1..64,1..64] of color4b;
begin
for x := 1 to 64 do
 for y := 1 to 64 do
 begin
 image[x,y,1] := 255;
 image[x,y,2] := 255;
 image[x,y,3] := 255;
 image[x,y,4] := 255;
 if random(60) = 3 then
 begin
 image[x,y,1] := 70+random(10);
 image[x,y,2] := 70+random(10);
 image[x,y,3] := 70+random(10);
 end;
 end;
 inherited create(aid,64,64,@image);
setENHcol([GLCL_AMBIENT],0.33,0.3,0.3,0.7);
setENHcol([GLCL_DIFFUSE],0.9,0.9,0.9,0.6);
setENHcol([GLCL_SPECULAR],0.5,0.5,0.55,0.6);
 shine := 110;
end;


constructor tglFunnyMarble.create(aid : smallint);
var
x,y : integer;
image : array[1..64,1..64] of color4b;
begin
for x := 1 to 64 do
 for y := 1 to 64 do
 begin
 image[x,y,1] := 220 + random(30);
 image[x,y,2] := 220 + random(30);
 image[x,y,3] := 220 + random(30);
 image[x,y,4] := 255;
 if random(20) = 3 then
 begin
 image[x,y,1] := random(250);
 image[x,y,2] := random(250);
 image[x,y,3] := random(250);
 image[x,y,4] := 255;
 end;
 end;
 inherited create(aid,64,64,@image);
 setEnhCOl([glcl_AMBIENT],1,1,1,1);
 setEnhCOl([glcl_DIFFUSE],0.7,0.75,0.7,1);
 setEnhCOl([glcl_SPECULAR],0.1,0.1,0.15,1);
 shine := 10;
end;

end.
