unit vect3d;

interface {Just like in glAux except GLDouble -> single}
type
{tpoint3d = record x,y,z : single end;}
tpoint3d = array[0..2] of single;
ppoint3d = ^tpoint3d;
procedure diff3(p,q : tpoint3d;var diff : tpoint3d);
procedure add3(p,q : tpoint3d;var sum : tpoint3d);
procedure scalarmult(s:single;v : tpoint3d;var vout : tpoint3d);{FACTICALLY,ITS NOT SCALAR}
function dot3(p,q : tpoint3d) : single;
function length3(v : tpoint3d) : single;
function dist3(p,q : tpoint3d) : single;
procedure copy3(old : tpoint3d;var new : tpoint3d);
procedure crossprod(v1,v2 : tpoint3d;var prod : tpoint3d);
procedure  normalize(var v : tpoint3d);
procedure perpnorm(p1,p2,p3 : tpoint3d;var n : tpoint3d);



(*
void identifymat3(GLdouble m[3][3])
{
    int i, j;

    for (i=0; i<3; i++)
        for (j=0; j<3; j++)
            m[i][j] = (i == j) ? (GLdouble)1.0 : (GLdouble)0.0;
}

void copymat3(GLdouble *to, GLdouble *from)
{
    int i;

    for (i=0; i<9; i++) {
        *to++ = *from++;
    }
}

void xformvec3(GLdouble v[3], GLdouble m[3][3], GLdouble vm[3])
{
    GLdouble result[3]; /* in case v == vm */
    int i;

    for (i=0; i<3; i++) {
        result[i] = v[0]*m[0][i] + v[1]*m[1][i] + v[2]*m[2][i];
    }
    for (i=0; i<3; i++) {
        vm[i] = result[i];
    }
}

long samepoint(GLdouble p1[3], GLdouble p2[3])
{
    if (p1[0] == p2[0] && p1[1] == p2[1] && p1[2] == p2[2])
        return 1;
    return 0;
}
  *)


implementation
procedure diff3(p,q : tpoint3d;var diff : tpoint3d);
begin
    diff[0] := p[0] - q[0];
    diff[1] := p[1] - q[1];
    diff[2] := p[2] - q[2];
end;


procedure add3(p,q : tpoint3d;var sum : tpoint3d);
begin
    sum[0] := p[0] + q[0];
    sum[1] := p[1] + q[1];
    sum[2] := p[2] + q[2];
end;
procedure scalarmult(s:single;v : tpoint3d;var vout : tpoint3d);{FACTICALLY,ITS NOT SCALAR}
begin
    vout[0] := v[0]*s;
    vout[1] := v[1]*s;
    vout[2] := v[2]*s;
end;

function dot3(p,q : tpoint3d) : single;
begin
    dot3 := p[0]*q[0] + p[1]*q[1] + p[2]*q[2];
end;

function length3(v : tpoint3d) : single;
begin
    length3 :=  sqrt(v[0]*v[0] + v[1]*v[1] + v[2]*v[2]);
end;

function dist3(p,q : tpoint3d) : single;
var d : tpoint3d;
begin
    diff3(p, q, d);
    dist3 := length3(d);
end;

procedure copy3(old : tpoint3d;var new : tpoint3d);
begin
    new[0] := old[0]; new[1] := old[1]; new[2] := old[2];
end;

procedure crossprod(v1,v2 : tpoint3d;var prod : tpoint3d);
var p : tpoint3d;      { in case prod == v1 or v2 }
begin
    p[0] := v1[1]*v2[2] - v2[1]*v1[2];
    p[1] := v1[2]*v2[0] - v2[2]*v1[0];
    p[2] := v1[0]*v2[1] - v2[0]*v1[1];
    prod[0] := p[0]; prod[1] := p[1]; prod[2] := p[2];
end;

procedure  normalize(var v : tpoint3d);
var d:single;
begin
    d := sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
    if (d = 0.0) then begin
{        error("normalize: zero length vector");}
        d := 1;
        v[0] := 1.0;
    end;
    d := 1/d;
    v[0] := v[0]*d; v[1]:=  v[1]* d; v[2]:= v[2] * d;
end;


procedure perpnorm(p1,p2,p3 : tpoint3d;var n : tpoint3d);
var d1, d2 : tpoint3d;
begin
    diff3(p2, p1, d1);
    diff3(p2, p3, d2);
    crossprod(d1, d2, n);
    normalize(n);
end;

end.
